/************************/
/* William Taylor	*/
/* March 18, 1991	*/
/* Version 1.0: 6/17/91 */
/* Version 1.1: 10/7/91 */
/* XtMenu Program	*/
/************************/
/*
 * Copyright 1991, William Taylor
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the user name not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  William Taylor makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * Author: William Taylor
 */

	/* #define DEBUG */
#define XAW_BC

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <fcntl.h>
	/* Used for umask in backquote */
/* #include <sys/stat.h> */

#include <X11/X.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>

#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>

	/* Modified vroot.h for tvtwm */
#include "vroot.h"

#include "bitmaps/menu"		/* Menu Icon */

Pixel White;
Pixel Black;

#define MAX_SWITCHES 30
int max_switches;

Window selection;
char *select_string;	/* String for selection execution (NULL if blank) */
int selection_owner;	/* 0 = Not Selection Owner, 1 = Selection Owner */
int selection_item;	/* The menu item of '!select' */
#define NO_SELECT 1023
Window select_child;	/* For later Raise or Lower Request from Selection */
XEvent button_event;
unsigned int button_state;

Cursor cursor_hand, cursor_dot, cursor_middle_button, cursor_skull;

#define MAX_STRING 128
#define MAX_SWITCH_LAB 63
#define MAX_SWITCH_COM 1024

#define MAX_POPUP_WIDTH 500
#define DEFAULT_DISTANCE 4

Dimension switch_width, switch_height;

#define X_SPACE 6
#define Y_SPACE 6

#define X_OFFSET 5
#define Y_OFFSET 5

#define SWITCH_X 20
#define SWITCH_Y 20

	/* Multiple Command Separator Character */
char separator_char;
	/* '$' Substitution Character */
char substitution_char;

	/* Allow a command to 'halt' multi-command execution */
int command_currently;		/* Are we currently halting on a command? */
#define NOT_IN_PROGRESS 0
#define IN_PROGRESS 1
unsigned int command_item;	/* Command client_data for halted command */
int command_loc;		/* Command Location for halted command */
char *command_string;		/* Command String for halted command */
int command_id;			/* Command ID for halted command */
int command_send_event;		/* 0=no send event, 1=send event */
Position x_loc_old, y_loc_old;	/* Old !setenv coordinates */

#define CHECK1_COMMAND_IN_PROGRESS \
  if (command_currently == IN_PROGRESS) \
    { \
    switch_execution(command_item); \
    }

#define CHECK2_COMMAND_IN_PROGRESS \
  if (command_currently == IN_PROGRESS && id == command_id) \
    { \
    switch_execution(command_item); \
    }

int global_id;			/* Global id */

	/* Various Execution Requests */
#define LOWER_REQUEST			0
#define RAISE_REQUEST			1
#define SELECT_REQUEST			2
#define DELETE_REQUEST			3
#define PRINT_REQUEST			4
#define ICONIFY_REQUEST			5
#define MODIFY_REQUEST			6
#define SELECT_KEY_REQUEST		7
#define DELETE_KEY_REQUEST		8
#define MODIFY_KEY_REQUEST		9
#define POINTER_UP_KEY_REQUEST		10
#define POINTER_DOWN_KEY_REQUEST	11
#define EXECUTE_ITEM_KEY_REQUEST	12

/* -------------------------------------------------------------*/

	/***********/
	/* Display */
	/***********/
Display *dpy;

	/***************/
	/* Root Window */
	/***************/
Window Root_Window;

	/********************/
	/* Top Level Window */
	/********************/
Window Top_Window;

	/************************/
	/* Environment Routines */
	/************************/
extern char *getenv();

	/*********************/
	/* User Input String */
	/*********************/
char input_string[MAX_STRING+1];
int input_str_loc;
int key_save_on;

	/*************/
	/* Top Level */
	/*************/
Widget topLevel;
Widget switchbox;

	/*********************/
	/* Message Structure */
	/*********************/
typedef struct {
  Widget message_pshell;
  char  *message_str;
  int    message_id;
} message_struct;

	/******************/
	/* File Structure */
	/******************/
typedef struct {
  Widget file_pshell;
  char  *file_str;
  int    file_id;
} file_struct;

	/*********/
	/* Error */
	/*********/
Widget error_pshell, error_form, error_continue, error_text;
#define MAX_ERROR_LEN 128
char error_str[MAX_ERROR_LEN];
int error_type;
#define NO_ERROR_TYPE 0
#define WRITE_ERROR_TYPE 1
Widget error_extra[2];
char error_extra_str[2][16];

	/**********/
	/* Insert */
	/**********/
Widget insert_pshell, insert_form, insert_cancel, insert_ok,
	insert_text1, insert_text2;
int insert_cnt;
#define NO_INSERT_CNT 0
String insert_str1, insert_str2;

	/**********/
	/* Modify */
	/**********/
Widget modify_pshell, modify_form, modify_cancel, modify_ok,
	modify_text1, modify_text2;
int modify_cnt;
#define NO_MODIFY_CNT 0
String modify_str1, modify_str2;

	/**********/
	/* Setenv */
	/**********/
Widget setenv_pshell, setenv_form, setenv_cancel, setenv_ok,
	setenv_text1, setenv_text2;
int setenv_cnt;
#define NO_SETENV_CNT 0
String setenv_str1, setenv_str2;

	/*********/
	/* Write */
	/*********/
Widget write_pshell, write_form, write_cancel, write_ok,
	write_text;
String write_str;

	/* Memory Allocation Macros */

#ifdef DEBUG

char *malloc_len(length)
unsigned int length;
{
  (void) printf("MALLOC_LEN %d\n",length);
  return((char *)malloc(length));
}

char *malloc_str(string)
char *string;
{
  (void) printf("MALLOC_STR [%d] '%s'\n",strlen(string)+1,string);
  return((char *)malloc((unsigned)strlen(string)+1));
}

free_str(string)
char *string;
{
  if (string == NULL)
    {
    (void) printf("FREE [0] '<NULL>'\n");
    }
  else
    {
    (void) printf("FREE [%d] '%s'\n",strlen(string)+1,string);
    free(string);
    }
}

#endif

#ifdef DEBUG
#define MALLOC_LEN(STRLEN) (char *)malloc_len(STRLEN)
#else
#define MALLOC_LEN(STRLEN) (char *)malloc((unsigned)(STRLEN))
#endif

#ifdef DEBUG
#define MALLOC_STR(STR) (char *)malloc_str(STR)
#else
#define MALLOC_STR(STR) (char *)malloc((unsigned)strlen(STR)+1)
#endif

#ifdef DEBUG
#define FREE(STR)   free_str(STR)
#else
#define FREE(STR)   if (STR != NULL) free(STR)
#endif

#ifdef DEBUG
#define STR_CPY(STR2,STR1) \
	(void) printf("STR_CPY '%s'\n",STR1); \
	STR2 = (char *)malloc_str(STR1); \
	(void) strcpy(STR2,STR1);
#else
#define STR_CPY(STR2,STR1) \
	STR2 = (char *)malloc((unsigned)strlen(STR1)+1); \
	(void) strcpy(STR2,STR1);
#endif

#ifdef DEBUG
#define STRING_COPY(STR2,STR1) \
	(void) printf("STRING_COPY '%s'\n",STR1); \
	(void) strcpy(STR2,STR1);
#else
#define STRING_COPY(STR2,STR1) \
	(void) strcpy(STR2,STR1);
#endif

	/*****************/
	/* Switch Labels */
	/*****************/
Widget switches[MAX_SWITCHES];		/* Switch Widgets */
int alive[MAX_SWITCHES];		/* 0=Not Alive, 1=Alive */
int lookup[MAX_SWITCHES];		/* Lookup Table for Live Switches */
int label_item[MAX_SWITCHES];		/* 0=Command, 1=Label */
char switch_lab[MAX_SWITCHES][MAX_SWITCH_LAB+1];  /* Switch Label String */
char *switch_com[MAX_SWITCHES];			  /* Switch Command String */

	/***********************/
	/* Switch Translations */
	/***********************/
/* Outline Border on Entering Window, Inverse Widget on Button */
static char switchCommandTranslations[] = "#override\n\
	<EnterWindow>:highlight()\n\
	<LeaveWindow>:reset()\n\
	<Btn1Down>:set()\n\
	<Btn1Up>:notify() unset()\n\
	<Btn2Down>:set()\n\
	<Btn2Up>:notify() unset()\n\
	<Btn3Down>:set()\n\
	<Btn3Up>:notify() unset()";

/* Inverse Widget on Entering Window */
/* static char switchCommandTranslations[] = "#override\n\
	<EnterWindow>:set()\n\
	<LeaveWindow>:unset()\n\
	<Btn1Down>:null()\n\
	<Btn1Up>:notify()\n\
	<Btn2Down>:null()\n\
	<Btn2Up>:notify()\n\
	<Btn3Down>:null()\n\
	<Btn3Up>:notify()"; */

/* Do Nothing */
static char switchLabelTranslations[] = "#override\n\
	<EnterWindow>:null()\n\
	<LeaveWindow>:null()\n\
	<Btn1Down>:null()\n\
	<Btn1Up>:null()\n\
	<Btn2Down>:null()\n\
	<Btn2Up>:null()\n\
	<Btn3Down>:null()\n\
	<Btn3Up>:null()";

XtTranslations switch_command_translations;
XtTranslations switch_label_translations;

/* -------------------------------------------------------------*/

	/* Data Structure for Application Resources */
  typedef struct {
	Boolean tvtwm;
	Boolean noquit;
	Boolean horizontal;
	String menu;
	Boolean help;
	Boolean printHelp;
	Boolean std_in;
	String sep;
	String sub;
	Boolean keySave;
	Boolean highlight;
	} AppData, *AppDataPtr;

  AppData app_data;

/* -------------------------------------------------------------*/

static char user_help[] = "Welcome to the XtMenu Program\n\n\
Version 1.1 (October 7, 1991)\n\n\
By William Taylor (wrt@steve.cray.com)\n\n\
Command Line Options:\n\
\t-help		Popup Help Menu [Default off] (Resource *help)\n\
\t-print_help	Print Help to stdout [off] (*printHelp)\n\
\t-m <file>	Read Menu from File [NULL] (*menu)\n\
\t-stdin		Read Menu from Standard Input [off] (*std_in)\n\
\t-noquit		Do not quit after first button press [false] (*noquit)\n\
\t-horizontal	Pop-up Menu Horizontally [vert] (*horizontal)\n\
\t-tvtwm		Using Virtual Desktop Features [false] (*tvtwm)\n\
\t-sep <char>	Multi-command separator ['#'] (*sep)\n\
\t-sub <char>	Environment substitution ['@'] (*sub)\n\
\t-keysave	Turn Off Key Saves at Startup [keysaveon] (*keySave)\n\
\t+keysave	Turn On Key Saves at Startup [keysaveon] (*keySave)\n\
\t-highlight	Do Not Highlight Selected Item [highlight] (*highlight)\n\
\t+highlight	Highlight Selected Item [highlight] (*highlight)\n\
\n\
File Format:\n\
\t# Comment\n\
\t\042Blank Command\042\n\
\t\042Menu Command\042			!menu_command\n\
\t\042System Command\042		%system_command\n\
\t\042Execute in Target Window\042	>select_command\n\
\t\042Text Window\042			}text\n\
\t\042File Window\042			]file\n\
\t\042Multi-Command Separation\042	cmd1 # cmd2 # cmd3 ...\n\
\t\042Environment Substitution\042	@command\n\
\n\
Blank Commands:\n\
\tReturns Menu Item Number\n\
\n\
Menu Commands:\n\
\t!exit\t\t\tExits\n\
\t!help\t\t\tXtMenu Help\n\
\t!label\t\t\tA Plain Label\n\
\t!insert\t\t\tInsert a Menu Item\n\
\t!modify\t\t\tModify a Menu Item\n\
\t!select\t\t\tSelect a Target Window\n\
\t!delete\t\t\tDelete a Menu Item\n\
\t!raise\t\t\tRaise a Window\n\
\t!lower\t\t\tLower a Window\n\
\t!iconify\t\tIconify a Window\n\
\t!print_item\t\tPrint a Menu Item to stdout\n\
\t!print_menu\t\tPrint Entire Menu to stdout\n\
\t!write_menu\t\tWrite Menu to a File\n\
\t!read_menu\t\tRead Menu from a File\n\
\t!setenv [var [val]]\tSet an Environment Variable\n\
\n\
System Commands (examples):\n\
\t%ls -alg\n\
\t%xtmenu -tvtwm -noquit -geometry +$X+$Y -m menu.csh &\n\
\n\
System Commands (Environment Variables):\n\
\tITEM = Menu Label Text\n\
\tOCMD = Original Menu Command\n\
\tCMD  = Actual Menu Command\n\
\tX    = Pointer X Coordinate\n\
\tY    = Pointer Y Coordinate\n\
\n\
Selected Window Commands (examples)\n\
\t>ls -alg\\\\n\t\tExecute 'ls -alg' on Target Window\n\
\t>/usr/ucb/clear\\\\n\tClear Target Window\n\
\t>raise			Raise Target Window\n\
\t>lower			Lower Target Window\n\
\t>iconify		Iconify Target Window\n\
\t>deiconify		DeIconify Target Window\n\
\n\
Keyboard Translations:\n\
\tkey_press()		Any Key Press/Release Event\n\
\texec_item(#)		Execute an Item (1-max_items)\n\
\texit()			Exit (!exit)\n\
\ttoggle_key_save()	Toggle Keyboard Save\n\
\tinsert_item()		Insert Selected Item (!insert)\n\
\tmodify_item()		Modify Selected Item (!modify)\n\
\tsetenv_item([vr[,vl]])	Set Environment Variable (!setenv)\n\
\tdelete_item()		Delete Menu Item (!delete)\n\
\tdelete_last_item()	Delete Last Menu Item\n\
\tselect_item()		Select a Window (!select)\n\
\tprint_menu()		Print the menu (!print_menu)\n\
\twrite_menu()		Write Menu to a File (!write_menu)\n\
\tread_menu()		Read Menu from a File (!read_menu)\n\
\traise_selection()	Raise the Selected Window\n\
\tlower_selection()	Lower the Selected Window\n\
\traise_menu()		Raise the Menu\n\
\tlower_menu()		Lower the Menu\n\
\ticonify_selection()	Iconify the Selected Window\n\
\tdeiconify_selection()	DeIconify the Selected Window\n\
\tpointer_center()	Center the Pointer in the Menu\n\
\tpointer_up()		Move the Pointer Up 1 Item\n\
\tpointer_down()		Move the Pointer Down 1 Item\n\
\texec_current_item()	Execute Menu Item Under Pointer\n\
\tsync_up()		Synchronize the X Server\n\
\n\
Example Menu File:\n\
\t#\n\
\t# Menu.csh\n\
\t# William Taylor\n\
\t# July 29, 1991\n\
\t#\n\
\tXterm		%xterm &\n\
\tls		>ls\\\\n\n\
\t\042ls -alg\042	>ls -alg\\\\n\n\
\tpwd		>pwd\\\\n\n\
\tClear		>/usr/ucb/clear\\\\n\n\
\tItem		%echo \042$ITEM\042 ; echo \042$OCMD\042 ; echo \042$CMD\042\n\
\tSelection	!select\n\
\t# \042! Raise\042	!raise\n\
\t\042> Raise\042	>raise\n\
\t# \042! Lower\042	!lower\n\
\t\042> Lower\042	>lower\n\
\tDelete		!delete\n\
\tIconify		!iconify\n\
\tInsert		!insert\n\
\tModify		!modify\n\
\tLabel		!label\n\
\tHelp		!help\n\
\t\042Print Item\042	!print_item\n\
\t\042Print Menu\042	!print_menu\n\
\t\042NewMenu ->\042    %xtmenu -tvtwm -noquit -geometry +$X+$Y -m menu.csh &\n\
\t#\n\
\t# Multiple commands separated with a '#' character:\n\
\t\042EV? %echo $EV\042	!setenv EV # %echo $EV\n\
\t#\n\
\t# Environment variable substitution using an '@' character:\n\
\t\042EV? >echo $EV\042	!setenv EV # @>echo $EV\\\\n\n\
\t#\n\
\tQuit		!exit\n\
\n\
Example Keyboard Translation Table ($HOME/XtMenu):\n\
  *switchbox.translations:	#override\\\\n\\\\\n\
	None<KeyPress>F1:	exec_item(1)\\\\n\\\\\n\
	None<KeyPress>F2:	exec_item(2)\\\\n\\\\\n\
	None<KeyPress>F3:	exec_item(3)\\\\n\\\\\n\
	None<KeyPress>F4:	exec_item(4)\\\\n\\\\\n\
	None<KeyPress>F5:	exec_item(5)\\\\n\\\\\n\
	None<KeyPress>F6:	exec_item(6)\\\\n\\\\\n\
	None<KeyPress>F7:	exec_item(7)\\\\n\\\\\n\
	None<KeyPress>F8:	exec_item(8)\\\\n\\\\\n\
	None<KeyPress>F9:	exec_item(9)\\\\n\\\\\n\
	None<KeyPress>F10:	exec_item(10)\\\\n\\\\\n\
	None<KeyPress>F11:	exec_item(11)\\\\n\\\\\n\
	None<KeyPress>F12:	exec_item(12)\\\\n\\\\\n\
	Shift<KeyPress>F1:	exec_item(13)\\\\n\\\\\n\
	Shift<KeyPress>F2:	exec_item(14)\\\\n\\\\\n\
	Shift<KeyPress>F3:	exec_item(15)\\\\n\\\\\n\
	Shift<KeyPress>F4:	exec_item(16)\\\\n\\\\\n\
	Shift<KeyPress>F5:	exec_item(17)\\\\n\\\\\n\
	Shift<KeyPress>F6:	exec_item(18)\\\\n\\\\\n\
	Shift<KeyPress>F7:	exec_item(19)\\\\n\\\\\n\
	Shift<KeyPress>F8:	exec_item(20)\\\\n\\\\\n\
	Shift<KeyPress>F9:	exec_item(21)\\\\n\\\\\n\
	Shift<KeyPress>F10:	exec_item(22)\\\\n\\\\\n\
	Shift<KeyPress>F11:	exec_item(23)\\\\n\\\\\n\
	Shift<KeyPress>F12:	exec_item(24)\\\\n\\\\\n\
	Ctrl<KeyPress>F1:	setenv_item()\\\\n\\\\\n\
	Ctrl<KeyPress>F2:	setenv_item(\042HELLO\042)\\\\n\\\\\n\
	Ctrl<KeyPress>F3:	setenv_item(\042HELLO\042,\042hello\042)\\\\n\\\\\n\
	Ctrl<KeyPress>q:	exit()\\\\n\\\\\n\
	Ctrl<KeyPress>i:	insert_item()\\\\n\\\\\n\
	Ctrl<KeyPress>m:	modify_item()\\\\n\\\\\n\
	Ctrl<KeyPress>r:	delete_item()\\\\n\\\\\n\
	Ctrl<KeyPress>y:	delete_last_item()\\\\n\\\\\n\
	Ctrl<KeyPress>t:	select_item()\\\\n\\\\\n\
	Ctrl<KeyPress>p:	print_menu()\\\\n\\\\\n\
	Ctrl<KeyPress>o:	toggle_key_save()\\\\n\\\\\n\
	Ctrl<KeyPress>a:	deiconify_selection() raise_selection() raise_menu()\\\\n\\\\\n\
	Ctrl<KeyPress>s:	iconify_selection()\\\\n\\\\\n\
	Ctrl<KeyPress>j:	pointer_down()\\\\n\\\\\n\
	Ctrl<KeyPress>k:	pointer_up()\\\\n\\\\\n\
	Ctrl<KeyPress>l:	exec_current_item()\\\\n\\\\\n\
 	Ctrl<KeyPress>w:	write_menu()\\\\n\\\\\n\
 	Ctrl<KeyPress>e:	read_menu()\\\\n\\\\\n\
	<KeyPress>:		key_press()\\\\n\\\\\n\
	<KeyRelease>:		key_press()\n\
\n\
Comments and Suggestions are Welcome.";

/* -------------------------------------------------------------*/

static void print_menu();
static void write_menu();
static void WriteCallback();
static void ReadCallback();
static void read_menu();
static void switch_callback();
static char * convert_after_modify();
static char * convert_before_modify();
char *backquote_chk();

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
exec_item(widget, event, strings, count)
Widget widget;
XEvent *event;
String *strings;
Cardinal *count;
{
  int item;

#ifdef DEBUG
  (void) printf("Execute Item '%s'\n",strings[0]);
#endif

  item = atoi(strings[0]);

  if (item > 0 && item <= max_switches)
    {
    item = lookup[item-1];
    switch_callback(switches[item], (unsigned int)item, (caddr_t)NULL);
    }
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
key_press(widget, event)
Widget widget;
XEvent *event;
{
#define MAX_KEYBOARD_STRING 16
  char buffer[MAX_KEYBOARD_STRING];
  int bufsize = MAX_KEYBOARD_STRING;
  KeySym keysym;
  XComposeStatus compose;
  int count;
  int add;
  char *string2;
  int found;

  if (event->type == KeyPress || event->type == KeyRelease)
    {
#ifdef DEBUG
    (void) printf("Key Press/Release (Keycode %d)\n", event->xkey.keycode);
#endif
    if (selection != 0)
      {
      event->xkey.send_event = True;
      event->xkey.time = CurrentTime;
      event->xkey.window = button_event.xbutton.window;
      event->xkey.root = button_event.xbutton.root;
      event->xkey.subwindow = button_event.xbutton.subwindow;
      event->xkey.x = button_event.xbutton.x;
      event->xkey.y = button_event.xbutton.y;
      event->xkey.x_root = button_event.xbutton.x_root;
      event->xkey.y_root = button_event.xbutton.y_root;
      XSendEvent(dpy,
	button_event.xbutton.window,
	True,
	None,
	event);

      if (key_save_on == 1 && event->type == KeyPress)
        {
		/* (See OReilly p. 254, Volume 1, Chapter 9) */
        count = XLookupString(event, buffer, bufsize,
		&keysym, &compose);

        if (keysym == XK_Return || keysym == XK_KP_Enter ||
		keysym == XK_Linefeed)
          {
#ifdef DEBUG
          (void) printf("input_string = '%s'\n",input_string);
#endif
          if (strlen(input_string) > 0 && max_switches < MAX_SWITCHES)
            {
            string2 = MALLOC_LEN(strlen(input_string)+4);
            string2[0] = '>';
            string2[1] = '\0';
            (void) strcat(string2, input_string);
            (void) strcat(string2, "\\n");

            found = 0;
            for (add=0; add<max_switches; add++)
              if (strcmp(string2,switch_com[lookup[add]]) == 0)
                {found = 1;
                break;}

            if (found == 1)
              {
              FREE(string2);
              }
            else
              {
              for (add=0; add<MAX_SWITCHES; add++)
                {
                if (! alive[add]) break;
                }

              lookup[max_switches] = add;

              STRING_COPY(switch_lab[add], input_string);
              switch_com[add] = string2;

              add_switch();
              }
            }

          input_string[0] = '\0';
          input_str_loc = 0;
          }
        else
          if (keysym == XK_BackSpace)
            {
#ifdef DEBUG
            (void) printf("BackSpace\n");
#endif
            if (input_str_loc > 0)
              {
              input_str_loc--;
              input_string[input_str_loc] = '\0';
              }
            }
          else
            if (keysym == XK_Delete)
              {
#ifdef DEBUG
              (void) printf("Delete\n");
#endif
              input_string[0] = '\0';
              input_str_loc = 0;
              }
            else
              {
              buffer[count] = '\0';
#ifdef DEBUG
              (void) printf("buffer = '%s' count=%d\n",buffer,count);
#endif
              if (count > 0)
                {
                input_str_loc += strlen(buffer);
                if (input_str_loc > MAX_STRING)
                  {/* XBell(dpy, 0);
                  (void) sprintf(error_str,"Input String Too Large...Clearing");
                  process_error(0); */
                  input_string[0] = '\0';
                  input_str_loc = 0;}
                else
                  (void) strcat(input_string, buffer);
                }
              }
        }

      }
    }
}

/* -------------------------------------------------------------*/

static void
null_action()
{
}

/* -------------------------------------------------------------*/

static void
menu_quit()
{
  exit(0);
}

/* -------------------------------------------------------------*/

static void insert_item();

/* -------------------------------------------------------------*/

static void
modify_item()
{
  if (modify_cnt == NO_MODIFY_CNT)
    (void) exec_request(MODIFY_KEY_REQUEST);
  else
    {XBell(dpy, 0);
    (void) sprintf(error_str,"Only 1 Modify may take place at a time.");
    process_error(0);}
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
setenv_item(widget, event, strings, count)
Widget widget;
XEvent *event;
String *strings;
Cardinal *count;
{
  int cnt;
  char *str;

  cnt = *count;

#ifdef DEBUG
  (void) printf("Setenv Item Count %d\n",cnt);
  if (cnt > 0)
    (void) printf("  Strings[0]='%s'\n",strings[0]);
  if (cnt > 1)
    (void) printf("  Strings[1]='%s'\n",strings[1]);
#endif

  if (cnt < 0 || cnt > 2)
    {
    (void) fprintf(stderr,"Usage: setenv_item([var[,val]])\n");
    return;
    }

  switch (cnt)
    {
    case 0:
      STR_CPY(str,"!setenv");
      break;
    case 1:
      str = MALLOC_LEN(9+strlen(strings[0]));
      str[0] = '\0';
      (void) strcat(str, "!setenv ");
      (void) strcat(str, strings[0]);
      break;
    case 2:
      str = MALLOC_LEN(10+strlen(strings[0])+strlen(strings[1]));
      str[0] = '\0';
      (void) strcat(str, "!setenv ");
      (void) strcat(str, strings[0]);
      (void) strcat(str, " ");
      (void) strcat(str, strings[1]);
      break;
    }
  
  (void) setenv_command(str);

  FREE(str);
}

/* -------------------------------------------------------------*/

static void
delete_item()
{
  (void) exec_request(DELETE_KEY_REQUEST);
}

/* -------------------------------------------------------------*/

static void
select_item()
{
  (void) exec_request(SELECT_KEY_REQUEST);
}

/* -------------------------------------------------------------*/

static void
delete_last_item()
{
  Position x_loc, y_loc;
  int loc;

  query_position(&x_loc, &y_loc);

  loc = max_switches - 2;
  if (loc < 0) loc = 0;

  if (app_data.horizontal)
    {
    if (x_loc > (int)(loc * (switch_width + (2*(DEFAULT_DISTANCE-1))) +
	(switch_width / 2) + DEFAULT_DISTANCE))
      warp_to_location(max_switches-2);
    }
  else
    {
    if (y_loc > (int)(loc * (switch_height + (2*(DEFAULT_DISTANCE-1))) +
	(switch_height / 2) + DEFAULT_DISTANCE))
      warp_to_location(max_switches-2);
    }

  delete_switch(max_switches-1);
}

/* -------------------------------------------------------------*/

static void
raise_selection()
{
if (selection == 0)
  {
  XBell(dpy, 0);
  (void) sprintf(error_str,"Window Not Selected.  Command '!select' is needed first.\n");
  process_error(0);
  }

XRaiseWindow(dpy, select_child);
}

/* -------------------------------------------------------------*/

static void
lower_selection()
{
if (selection == 0)
  {
  XBell(dpy, 0);
  (void) sprintf(error_str,"Window Not Selected.  Command '!select' is needed first.\n");
  process_error(0);
  }

XLowerWindow(dpy, select_child);
}

/* -------------------------------------------------------------*/

static void
raise_menu()
{
XRaiseWindow(dpy, Top_Window);
}

/* -------------------------------------------------------------*/

static void
lower_menu()
{
XLowerWindow(dpy, Top_Window);
}

/* -------------------------------------------------------------*/

static void
iconify_selection()
{
if (selection == 0)
  {
  XBell(dpy, 0);
  (void) sprintf(error_str,"Window Not Selected.  Command '!select' is needed first.\n");
  process_error(0);
  }

iconify_window(select_child);
}

/* -------------------------------------------------------------*/

static void
deiconify_selection()
{
if (selection == 0)
  {
  XBell(dpy, 0);
  (void) sprintf(error_str,"Window Not Selected.  Command '!select' is needed first.\n");
  process_error(0);
  }

XMapWindow(dpy, select_child);
}

/* -------------------------------------------------------------*/

static void
toggle_key_save()
{
  key_save_on ^= 1;
  if (! key_save_on)
    {input_string[0] = '\0';
    input_str_loc = 0;}
}

/* -------------------------------------------------------------*/

static void
pointer_center()
{
  int i;
  Arg args[5];
  Dimension top_width, top_height;
  int width, height;

  i=0;
  XtSetArg(args[i], XtNheight, &top_height); i++;
  XtSetArg(args[i], XtNwidth, &top_width); i++;
  XtGetValues(topLevel, args, i);

  width = top_width / 2;
  height = top_height / 2;

  XWarpPointer(dpy, None, Top_Window, 0, 0, 0, 0, width, height);
}

/* -------------------------------------------------------------*/

static void
pointer_up()
{
  (void) exec_request(POINTER_UP_KEY_REQUEST);
}

/* -------------------------------------------------------------*/

static void
pointer_down()
{
  (void) exec_request(POINTER_DOWN_KEY_REQUEST);
}

/* -------------------------------------------------------------*/

static void
exec_current_item()
{
  (void) exec_request(EXECUTE_ITEM_KEY_REQUEST);
}

/* -------------------------------------------------------------*/

static void
sync_up()
{
  XSync(dpy, False);
}

/* -------------------------------------------------------------*/

static void
write_menu()
{
  int i;
  Arg args[20];
  Position x_loc, y_loc;
  Dimension height, width;

  query_location(&x_loc, &y_loc, 0);

#ifdef DEBUG
  (void) printf("Popup Write Menu\n");
#endif

  i = 0;
  XtSetArg(args[i], XtNlabel, "Write"); i++;
  XtSetValues(write_ok, args, i);
  XtRemoveAllCallbacks(write_ok, XtNcallback);
  XtAddCallback(write_ok, XtNcallback, WriteCallback, 1);

  i = 0;
  XtSetArg(args[i], XtNstring, ""); i++;
  XtSetValues(write_text, args, i);

  height = 2 * (switch_height+Y_SPACE) + Y_SPACE;
  width = MAX_POPUP_WIDTH;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, width); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  XtSetValues(write_pshell, args, i);

  XtPopup(write_pshell, XtGrabNonexclusive);
}

/* -------------------------------------------------------------*/

static void
read_menu()
{
  int i;
  Arg args[20];
  Position x_loc, y_loc;
  Dimension height, width;

  query_location(&x_loc, &y_loc, 0);

#ifdef DEBUG
  (void) printf("Popup Read Menu\n");
#endif

  i = 0;
  XtSetArg(args[i], XtNlabel, "Read"); i++;
  XtSetValues(write_ok, args, i);
  XtRemoveAllCallbacks(write_ok, XtNcallback);
  XtAddCallback(write_ok, XtNcallback, ReadCallback, 1);

  i = 0;
  XtSetArg(args[i], XtNstring, ""); i++;
  XtSetValues(write_text, args, i);

  height = 2 * (switch_height+Y_SPACE) + Y_SPACE;
  width = MAX_POPUP_WIDTH;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, width); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  XtSetValues(write_pshell, args, i);

  XtPopup(write_pshell, XtGrabNonexclusive);
}

/* -------------------------------------------------------------*/

int
errorhandler(display, event)
Display *display;
XErrorEvent *event;
{
  if (event->error_code == 3 && event->minor_code == 0 &&
	(event->request_code == 25 || event->request_code == 12 ||
	event->request_code == 8))
    {
    XBell(dpy, 0);
    (void) sprintf(error_str,"Select Window Destroyed.  Please Select a New Window.");
    process_error(0);
    }
  else
    {
    XGetErrorText(display, event->error_code, error_str, MAX_ERROR_LEN);
    (void) fprintf(stderr,"XtMenu Error (%d) %s\n",event->error_code,error_str);
    (void) fprintf(stderr,"  Major Code %d\n",event->request_code);
    (void) fprintf(stderr,"  Minor Code %d\n",event->minor_code);
    }
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
InsertCallback(w, client_data, call_data)
Widget w;
unsigned int client_data;
caddr_t call_data;
{
  int i;
  Arg args[10];
  int add;

  XtPopdown(insert_pshell);

	/* User requested 'cancel' */
  if (client_data == 0)
    {
    command_currently = NOT_IN_PROGRESS;
    goto done_insert;
    }

  for (add=0; add<MAX_SWITCHES; add++)
    {
    if (! alive[add]) break;
    }

  lookup[max_switches] = add;

  i = 0;
  XtSetArg(args[i], XtNstring, &insert_str1); i++;
  XtGetValues(insert_text1, args, i);

  i = 0;
  XtSetArg(args[i], XtNstring, &insert_str2); i++;
  XtGetValues(insert_text2, args, i);

#ifdef DEBUG
  (void) printf("Insert: User selected (%d) '%s' for '%s'\n",client_data,
	insert_str1,insert_str2);
#endif

  STRING_COPY(switch_lab[add], insert_str1);
  STR_CPY(switch_com[add], insert_str2);

  add_switch();

done_insert:
  i = 0;
  XtSetArg(args[i], XtNstring, ""); i++;
  XtSetValues(insert_text1, args, i);

  i = 0;
  XtSetArg(args[i], XtNstring, ""); i++;
  XtSetValues(insert_text2, args, i);

  insert_cnt = NO_INSERT_CNT;

  CHECK1_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
ModifyCallback(w, client_data, call_data)
Widget w;
unsigned int client_data;
caddr_t call_data;
{
  int i;
  Arg args[10];
  int modify;

  XtPopdown(modify_pshell);

  modify = modify_cnt - 1;

  modify_cnt = NO_MODIFY_CNT;

	/* User requested 'cancel' */
  if (client_data == 0)
    {
    command_currently = NOT_IN_PROGRESS;
    return;
    }

  i = 0;
  XtSetArg(args[i], XtNstring, &modify_str1); i++;
  XtGetValues(modify_text1, args, i);

  i = 0;
  XtSetArg(args[i], XtNstring, &modify_str2); i++;
  XtGetValues(modify_text2, args, i);

#ifdef DEBUG
  (void) printf("Modify: User selected (%d) '%s' for '%s'\n",
	client_data, modify_str1, modify_str2);
#endif

  FREE(switch_com[modify]);

  STRING_COPY(switch_lab[modify],modify_str1);

  switch_com[modify] = convert_after_modify(modify_str2);

  i=0;

  if (strcmp(modify_str2,"!label") == 0)
    {
    XtSetArg(args[i], XtNborderColor, White); i++;
    XtSetArg(args[i], XtNhighlightThickness, 0); i++;
    XtSetArg(args[i], XtNtranslations, switch_label_translations); i++;
    label_item[modify] = 1;
    }
  else
    {
    XtSetArg(args[i], XtNborderColor, Black); i++;
    XtSetArg(args[i], XtNhighlightThickness, 1); i++;
    XtSetArg(args[i], XtNtranslations, switch_command_translations); i++;
    label_item[modify] = 0;
    }

  XtSetArg(args[i], XtNlabel, switch_lab[modify]); i++;

  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNwidth,  switch_width); i++;

  XtSetValues(switches[modify], args, i); 

  CHECK1_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
SetenvCallback(w, client_data, call_data)
Widget w;
unsigned int client_data;
caddr_t call_data;
{
  int i;
  Arg args[10];
  char *value;

  XtPopdown(setenv_pshell);

  setenv_cnt = NO_SETENV_CNT;

	/* User requested 'cancel' */
  if (client_data == 0)
    {
    command_currently = NOT_IN_PROGRESS;
    return;
    }

  i = 0;
  XtSetArg(args[i], XtNstring, &setenv_str1); i++;
  XtGetValues(setenv_text1, args, i);

  i = 0;
  XtSetArg(args[i], XtNstring, &setenv_str2); i++;
  XtGetValues(setenv_text2, args, i);

#ifdef DEBUG
  (void) printf("Setenv: User selected (%d) '%s' for '%s'\n",
	client_data, setenv_str1, setenv_str2);
#endif

	/* Is Environment Variable Not Blank? */
  if (strlen(setenv_str1) > 0)
    {
    value = backquote_chk(setenv_str2);

    setenv_variable(setenv_str1, value);

	/* Don't ever FREE(setenv_str2) or FREE(setenv_str1)! */

    FREE(value);
    }

  CHECK1_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
WriteCallback(w, client_data, call_data)
Widget w;
unsigned int client_data;
caddr_t call_data;
{
  int i;
  Arg args[10];
  int x, y;
  FILE *write_file;

  XtPopdown(write_pshell);

	/* User requested 'cancel' */
  if (client_data == 0)
    {
    command_currently = NOT_IN_PROGRESS;
    return;
    }

  i = 0;
  XtSetArg(args[i], XtNstring, &write_str); i++;
  XtGetValues(write_text, args, i);

#ifdef DEBUG
  (void) printf("Write: User selected (%d) '%s'\n", client_data, write_str);
#endif

  if (strlen(write_str) < 1)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"Filename must not be blank.");
    process_error(0);
    command_currently = NOT_IN_PROGRESS;
    return;}

  write_file = fopen(write_str, "r");

  if (write_file == NULL)
    write_file = fopen(write_str, "a");
  else
    {(void) fclose(write_file);
    error_type = WRITE_ERROR_TYPE;
    (void) sprintf(error_extra_str[0],"OverWrite");
    (void) sprintf(error_extra_str[1],"Append");
    XBell(dpy, 0);
    (void) sprintf(error_str,"File '%s' Already Exists.",write_str);
    process_error(2);
    command_currently = NOT_IN_PROGRESS;
    return;}

  for (x=0; x<max_switches; x++)
    {
    y = lookup[x];
    print_item(write_file, y);
    }

  (void) fclose(write_file);

  CHECK1_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
ReadCallback(w, client_data, call_data)
Widget w;
unsigned int client_data;
caddr_t call_data;
{
  int i;
  Arg args[10];
  int x;
  FILE *read_file;
  int cnt;
  Dimension box_height, box_width;
  Dimension top_height, top_width;
  XSizeHints size_hints;

  Widget old_switches[MAX_SWITCHES];		/* Switch Widgets */
  int old_alive[MAX_SWITCHES];			/* 0=Not Alive, 1=Alive */
  char *old_switch_com[MAX_SWITCHES];		/* Switch Command String */

  Widget old_switchbox;

  XtPopdown(write_pshell);

  i = 0;
  XtSetArg(args[i], XtNstring, &write_str); i++;
  XtGetValues(write_text, args, i);

#ifdef DEBUG
  (void) printf("Read: User selected (%d) '%s'\n", client_data, write_str);
#endif

  if (strlen(write_str) < 1)
    {
    command_currently = NOT_IN_PROGRESS;
    return;
    }

  read_file = fopen(write_str, "r");

  if (read_file == NULL)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"File '%s' Not Found.",write_str);
    process_error(0);
    command_currently = NOT_IN_PROGRESS;
    return;}

  for (x=0; x<MAX_SWITCHES; x++)
    {
    old_alive[x] = alive[x];
    if (alive[x])
      {
      old_switch_com[x] = switch_com[x];
      old_switches[x] = switches[x];
      }
    }

  cnt = read_menu_file(read_file);

  (void) fclose(read_file);

  if (cnt == 0)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"Blank Menu File '%s'.",write_str);
    process_error(0);
    command_currently = NOT_IN_PROGRESS;
    return;}

  for (x=0; x<MAX_SWITCHES; x++)
    {
    if (old_alive[x])
      {
      FREE(old_switch_com[x]);
      XtDestroyWidget(old_switches[x]);
      }
    }

  old_switchbox = switchbox;

  switchbox = XtCreateManagedWidget("switchbox", boxWidgetClass,
	topLevel, args, 0);

  XtDestroyWidget(old_switchbox);

  max_switches = cnt;

  setup_switches(switchbox);

  if (app_data.horizontal)
    {
    box_width = max_switches*(switch_width+X_SPACE);
    box_height = switch_height+Y_SPACE;
    }
  else
    {
    box_width = switch_width+X_SPACE+DEFAULT_DISTANCE;
    box_height = max_switches*(switch_height+Y_SPACE)+DEFAULT_DISTANCE;
    }

  top_width = box_width;
  top_height = box_height;

  /* i=0;
  XtSetArg(args[i], XtNheight, box_height); i++;
  XtSetArg(args[i], XtNwidth, box_width); i++;
  XtSetValues(switchbox, args, i); */

  i=0;
  XtSetArg(args[i], XtNheight, top_height); i++;
  XtSetArg(args[i], XtNwidth, top_width); i++;
  XtSetValues(topLevel, args, i);

  for (x=0; x<max_switches; x++)
    {
    i=0;
    XtSetArg(args[i], XtNheight, switch_height); i++;
    XtSetArg(args[i], XtNwidth,  switch_width); i++;
    XtSetValues(switches[x], args, i);
    }

  size_hints.min_width  = top_width;
  size_hints.min_height = top_height;
  size_hints.max_width  = top_width;
  size_hints.max_height = top_height;

  size_hints.flags = PMinSize | PMaxSize;

  XSetNormalHints(dpy, Top_Window, &size_hints);

  CHECK1_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
MessageContinueCallback(w, client_data, call_data)
Widget w;
message_struct *client_data;
caddr_t call_data;
{
  Widget message_pshell;
  int id;

  FREE(client_data->message_str);

  message_pshell = client_data->message_pshell;
  id = client_data->message_id;

  FREE((char *)client_data);

  XtPopdown(message_pshell);

  XtDestroyWidget(message_pshell);

  CHECK2_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
FileContinueCallback(w, client_data, call_data)
Widget w;
file_struct *client_data;
caddr_t call_data;
{
  Widget file_pshell;
  int id;

  FREE(client_data->file_str);

  file_pshell = client_data->file_pshell;
  id = client_data->file_id;

  FREE((char *)client_data);

  XtPopdown(file_pshell);

  XtDestroyWidget(file_pshell);

  CHECK2_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
ErrorContinueCallback(w, client_data, call_data)
Widget w;
unsigned int client_data;
caddr_t call_data;
{
  int x, y;
  FILE *write_file;

  XtPopdown(error_pshell);

  switch (error_type)
    {
    case WRITE_ERROR_TYPE:
      XtDestroyWidget(error_extra[0]);
      XtDestroyWidget(error_extra[1]);
      if (client_data > 1)
        {
#ifdef DEBUG
        (void) printf("write_str = '%s'\n",write_str);
#endif
        if (client_data == 2)
          write_file = fopen(write_str, "w");
        else
          write_file = fopen(write_str, "a");

        for (x=0; x<max_switches; x++)
          {
          y = lookup[x];
          print_item(write_file, y);
          }

        (void) fclose(write_file);
        }
      break;
    }

  error_type = NO_ERROR_TYPE;
}

/* -------------------------------------------------------------*/

#define XtNtvtwm	"tvtwm"
#define XtCTvtwm	"Tvtwm"
#define XtNnoquit	"noquit"
#define XtCNoquit	"Noquit"
#define XtNhorizontal	"horizontal"
#define XtCHorizontal	"Horizontal"
#define XtNmenu		"menu"
#define XtCMenu		"Menu"
#define XtNhelp		"help"
#define XtCHelp		"Help"
#define XtNprintHelp	"printHelp"
#define XtCPrintHelp	"PrintHelp"
#define XtNstd_in	"std_in"
#define XtCStd_in	"Std_in"
#define XtNsep		"sep"
#define XtCSep		"Sep"
#define XtNsub		"sub"
#define XtCSub		"Sub"
#define XtNkeySave	"keySave"
#define XtCKeySave	"KeySave"
#define XtNhighlight	"highlight"
#define XtCHighlight	"Highlight"

	/* Resource List */
  static XtResource resources[] = {
		{
		XtNtvtwm,
		XtCTvtwm,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, tvtwm),
		XtRImmediate,
		(caddr_t) FALSE,
		},
		{
		XtNnoquit,
		XtCNoquit,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, noquit),
		XtRImmediate,
		(caddr_t) FALSE,
		},
		{
		XtNhorizontal,
		XtCHorizontal,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, horizontal),
		XtRImmediate,
		(caddr_t) FALSE,
		},
		{
		XtNmenu,
		XtCMenu,
		XtRString,
		sizeof(String),
		XtOffset(AppDataPtr, menu),
		XtRImmediate,
		(caddr_t) NULL,
		},
		{
		XtNhelp,
		XtCHelp,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, help),
		XtRImmediate,
		(caddr_t) FALSE,
		},
		{
		XtNprintHelp,
		XtCPrintHelp,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, printHelp),
		XtRImmediate,
		(caddr_t) FALSE,
		},
		{
		XtNstd_in,
		XtCStd_in,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, std_in),
		XtRImmediate,
		(caddr_t) FALSE,
		},
		{
		XtNsep,
		XtCSep,
		XtRString,
		sizeof(String),
		XtOffset(AppDataPtr, sep),
		XtRImmediate,
		(caddr_t) "#",
		},
		{
		XtNsub,
		XtCSub,
		XtRString,
		sizeof(String),
		XtOffset(AppDataPtr, sub),
		XtRImmediate,
		(caddr_t) "@",
		},
		{
		XtNkeySave,
		XtCKeySave,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, keySave),
		XtRImmediate,
		(caddr_t) TRUE,
		},
		{
		XtNhighlight,
		XtCHighlight,
		XtRBoolean,
		sizeof(Boolean),
		XtOffset(AppDataPtr, highlight),
		XtRImmediate,
		(caddr_t) TRUE,
		}
	};

	/* Actions List */
  static XtActionsRec actions[] = {
		{"exec_item",		exec_item},
		{"null",		null_action},
		{"exit",		menu_quit},
		{"insert_item",		insert_item},
		{"modify_item",		modify_item},
		{"setenv_item",		setenv_item},
		{"delete_item",		delete_item},
		{"select_item",		select_item},
		{"delete_last_item",	delete_last_item},
		{"print_menu",		print_menu},
		{"write_menu",		write_menu},
		{"read_menu",		read_menu},
		{"toggle_key_save",	toggle_key_save},
		{"raise_selection",	raise_selection},
		{"lower_selection",	lower_selection},
		{"raise_menu",		raise_menu},
		{"lower_menu",		lower_menu},
		{"iconify_selection",	iconify_selection},
		{"deiconify_selection",	deiconify_selection},
		{"pointer_center",	pointer_center},
		{"pointer_up",		pointer_up},
		{"pointer_down",	pointer_down},
		{"exec_current_item",	exec_current_item},
		{"sync_up",		sync_up},
		{"key_press",		key_press}
	}; 

	/* ----------------------- */

	/* Command-Line Options Table */
  static XrmOptionDescRec options[] = {
	{"-tvtwm",	"*tvtwm",	XrmoptionNoArg,  "True"},
	{"-noquit",	"*noquit",	XrmoptionNoArg,  "True"},
	{"-horizontal",	"*horizontal",	XrmoptionNoArg,  "True"},
	{"-m",		"*menu",	XrmoptionSepArg, NULL},
	{"-help",	"*help",	XrmoptionNoArg,  "True"},
	{"-print_help",	"*printHelp",	XrmoptionNoArg,  "True"},
	{"-stdin",	"*std_in",	XrmoptionNoArg,  "True"},
	{"-sep",	"*sep",		XrmoptionSepArg, NULL},
	{"-sub",	"*sub",		XrmoptionSepArg, NULL},
	{"-keysave",	"*keySave",	XrmoptionNoArg,  "False"},
	{"+keysave",	"*keySave",	XrmoptionNoArg,  "True"},
	{"-highlight",	"*highlight",	XrmoptionNoArg,  "False"},
	{"+highlight",	"*highlight",	XrmoptionNoArg,  "True"}
	};

/* -------------------------------------------------------------*/

	/****************/
	/* Main Program */
	/****************/
main(argc, argv)
int argc;
char **argv;
{
  int i;
  Arg args[20];
  Dimension top_height, top_width;
  XSizeHints size_hints;
  String string;

  int cnt;
  Position main_x, main_y;
  Boolean geometry_stmt;

  Pixmap icon_bitmap;

	/*************/
	/* Menu Name */
	/*************/
  char *menu_name;
  FILE *menu_file;

  geometry_stmt = FALSE;
  for (i=0; i<argc; i++)
    if (strcmp(argv[i],"-geometry") == 0)
      geometry_stmt = TRUE;

	/*************/
	/* top Level */
	/*************/
  topLevel = XtInitialize(argv[0], "XtMenu", options,
	XtNumber(options), &argc, argv);

	/* Get Application Resources */
  XtGetApplicationResources(topLevel,
	&app_data,
	resources,
	XtNumber(resources),
	NULL,
	0);

  if (app_data.printHelp)
    {
    STR_CPY(string, user_help);
    cnt = convert_str(string);
    (void) printf("%s\n",string);
    exit(0);
    }

	/* Register Actions with the Translation Manager */
  XtAddActions(actions, XtNumber(actions));

	/* Create Translations */
  switch_command_translations =
	XtParseTranslationTable(switchCommandTranslations);

  switch_label_translations =
	XtParseTranslationTable(switchLabelTranslations);

	/* Define Display */
  dpy = XtDisplay(topLevel);

	/* Define Root Window */
  if (app_data.tvtwm)
    Root_Window = VirtualRootWindow(dpy,DefaultScreen(dpy));
  else
    Root_Window = RootWindow(dpy,DefaultScreen(dpy));

        /* Highlight Pixel Values */
  White = WhitePixelOfScreen(XtScreen(topLevel));
  Black = BlackPixelOfScreen(XtScreen(topLevel));

	/*************************/
	/* top Level Icon Bitmap */
	/*************************/
  icon_bitmap = XCreateBitmapFromData(dpy,
	Root_Window, menu_bits,
        menu_width, menu_height);

  i=0;
  XtSetArg(args[i], XtNiconPixmap, icon_bitmap); i++;
  XtSetValues(topLevel, args, i);

	/******************/
	/* Create cursors */
	/******************/
  cursor_hand = XCreateFontCursor(dpy, XC_hand2);
  cursor_dot = XCreateFontCursor(dpy, XC_dot);
  cursor_middle_button = XCreateFontCursor(dpy, XC_middlebutton);
  cursor_skull = XCreateFontCursor(dpy, XC_pirate);

	/************************/
	/* Set Up Error Handler */
	/************************/
  XSetErrorHandler(errorhandler);

#ifdef DEBUG
  (void) printf("app_data.tvtwm=%d\n",app_data.tvtwm);
  (void) printf("app_data.noquit=%d\n",app_data.noquit);
  (void) printf("app_data.horizontal=%d\n",app_data.horizontal);
  (void) printf("app_data.menu='%s'\n",app_data.menu);
  (void) printf("app_data.help=%d\n",app_data.help);
  (void) printf("app_data.printHelp=%d\n",app_data.printHelp);
  (void) printf("app_data.std_in=%d\n",app_data.std_in);
  (void) printf("app_data.sep='%s'\n",app_data.sep);
  (void) printf("app_data.sub='%s'\n",app_data.sub);
  (void) printf("app_data.keysave=%d\n",app_data.keySave);
  (void) printf("app_data.highlight=%d\n",app_data.highlight);
#endif

  if (strlen(app_data.sep) != 1)
    {
    (void) fprintf(stderr,"Separator '%s' (-sep <char>) must be a single character. (Try xtmenu -help)\n", app_data.sep);
    exit(1);
    }

  if (strlen(app_data.sub) != 1)
    {
    (void) fprintf(stderr,"Substitution '%s' (-sub <char>) must be a single character. (Try xtmenu -help)\n", app_data.sub);
    exit(1);
    }

  separator_char = app_data.sep[0];
  substitution_char = app_data.sub[0];

  if (separator_char == substitution_char)
    {
    (void) fprintf(stderr,"Separator character ('%c') cannot be the substitution character ('%c'). (Try xtmenu -help)\n", separator_char, substitution_char);
    exit(1);
    }

  menu_name = NULL;

  if (app_data.help)

    {
    cnt = 0;
    STRING_COPY(switch_lab[cnt], "Help");
    STR_CPY(switch_com[cnt], "!help");
    cnt++;
    STRING_COPY(switch_lab[cnt], "Quit");
    STR_CPY(switch_com[cnt], "!exit");
    cnt++;
    app_data.noquit = TRUE;
    }

  else

    {
	/* Check for No Menu Specified */
    if (app_data.menu == NULL)
      {
      if (app_data.std_in)
        menu_file = stdin;
      else
        {
        (void) fprintf(stderr,"No Menu File Specified. (Try xtmenu -help)\n");
        exit(1);
        }
      }
    else
      {
      menu_file = fopen(app_data.menu, "r");
      if (menu_file == NULL)
        {
        (void) fprintf(stderr,"Menu File '%s' Not Readable. (Try xtmenu -help)\n",app_data.menu);
        exit(1);
        }
      STR_CPY(menu_name, app_data.menu);
      }

    cnt = read_menu_file(menu_file);

    if (cnt==0)
      {
      (void) fprintf(stderr,"Menu File '%s' is Blank. (Try xtmenu -help)\n",menu_name);
      exit(1);
      }

    if (menu_file != stdin)
      {
      (void) fclose(menu_file);
      FREE(menu_name);
      }
    }

  max_switches = cnt;
  selection = 0;
  select_string = NULL;
  selection_owner = 0;

  command_currently = NOT_IN_PROGRESS;
  global_id = 0;

  input_string[0] = '\0';
  input_str_loc = 0;

  if (app_data.keySave)
    key_save_on = 1;
  else
    key_save_on = 0;

	/* Initially set no selection */
  selection_item = NO_SELECT;

	/**************/
	/* switch box */
	/**************/
  switchbox = XtCreateManagedWidget("switchbox", boxWidgetClass,
	topLevel, args, 0);

  setup_switches(switchbox);

	/**********************/
	/* Insert Popup Shell */
	/**********************/
  create_insert_popup();

	/**********************/
	/* Modify Popup Shell */
	/**********************/
  create_modify_popup();

	/**********************/
	/* Modify SetenvShell */
	/**********************/
  create_setenv_popup();

	/*********************/
	/* Write Popup Shell */
	/*********************/
  create_write_popup();

	/*********************/
	/* Error Popup Shell */
	/*********************/
  create_error_popup();

	/***********************/
	/* Initialize topLevel */
	/***********************/
  XtRealizeWidget(topLevel);

	/* Define Top Level Window */
  Top_Window = XtWindow(topLevel);

  i=0;
  XtSetArg(args[i], XtNx, &main_x); i++;
  XtSetArg(args[i], XtNy, &main_y); i++;
  XtSetArg(args[i], XtNheight, &top_height); i++;
  XtSetArg(args[i], XtNwidth, &top_width); i++;
  XtGetValues(topLevel, args, i);

#ifdef DEBUG
  (void) printf("main_x=%d main_y=%d\n", main_x, main_y);
#endif

  size_hints.x          = main_x;
  size_hints.y          = main_y;
  size_hints.min_width  = top_width;
  size_hints.min_height = top_height;
  size_hints.max_width  = top_width;
  size_hints.max_height = top_height;

  if (geometry_stmt)
    size_hints.flags = USPosition | PMinSize | PMaxSize;
  else
    size_hints.flags = PMinSize | PMaxSize;

  XSetNormalHints(dpy, Top_Window, &size_hints);

  /* XtInstallAccelerators(topLevel, switchbox); */

  XtMainLoop();

  /* NOTREACHED */
}

/* -------------------------------------------------------------*/

	/**********************/
	/* Insert Popup Shell */
	/**********************/
create_insert_popup()
{
  int i;
  Arg args[20];

  insert_cnt = NO_INSERT_CNT;
  insert_str1 = NULL;
  insert_str2 = NULL;

  insert_pshell = XtCreateManagedWidget("insert_pshell",
	transientShellWidgetClass, topLevel, args, 0);

  insert_form = XtCreateManagedWidget("insert_form",
	formWidgetClass, insert_pshell, args, 0);

  i=0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Cancel"); i++;
  insert_cancel = XtCreateManagedWidget("insert_cancel",
	commandWidgetClass, insert_form, args, i);
  XtAddCallback(insert_cancel, XtNcallback, InsertCallback, 0);

  i=0;
  XtSetArg(args[i], XtNfromHoriz, insert_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Insert"); i++;
  insert_ok = XtCreateManagedWidget("insert_ok", commandWidgetClass,
	insert_form, args, i);
  XtAddCallback(insert_ok, XtNcallback, InsertCallback, 1);

  i = 0;
  XtSetArg(args[i], XtNfromVert, insert_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height+2); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable|resizeWidth); i++;

  insert_text1 = XtCreateManagedWidget("insert_text1", asciiTextWidgetClass,
	insert_form, args, i);

  i = 0;
  XtSetArg(args[i], XtNfromVert, insert_text1); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable|resizeWidth|scrollVertical); i++;

  insert_text2 = XtCreateManagedWidget("insert_text2", asciiTextWidgetClass,
	insert_form, args, i);
}

/* -------------------------------------------------------------*/

	/**********************/
	/* Modify Popup Shell */
	/**********************/
create_modify_popup()
{
  int i;
  Arg args[20];

  modify_cnt = NO_MODIFY_CNT;
  modify_str1 = NULL;
  modify_str2 = NULL;

  i = 0;
  XtSetArg(args[i], XtNallowShellResize, FALSE); i++;
  modify_pshell = XtCreateManagedWidget("modify_pshell",
	transientShellWidgetClass, topLevel, args, i);

  modify_form = XtCreateManagedWidget("modify_form", formWidgetClass,
	modify_pshell, args, 0);

  i=0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Cancel"); i++;
  modify_cancel = XtCreateManagedWidget("modify_cancel", commandWidgetClass,
	modify_form, args, i);
  XtAddCallback(modify_cancel, XtNcallback, ModifyCallback, 0);

  i=0;
  XtSetArg(args[i], XtNfromHoriz, modify_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Modify"); i++;
  modify_ok = XtCreateManagedWidget("modify_ok", commandWidgetClass,
	modify_form, args, i);
  XtAddCallback(modify_ok, XtNcallback, ModifyCallback, 1);

  i = 0;
  XtSetArg(args[i], XtNfromVert, modify_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height+2); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable); i++;
  /* XtSetArg(args[i], XtNuseStringInPlace, FALSE); i++; */

  modify_text1 = XtCreateManagedWidget("modify_text1",
	asciiTextWidgetClass, modify_form, args, i);

  i = 0;
  XtSetArg(args[i], XtNfromVert, modify_text1); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable|scrollVertical); i++;
  /* XtSetArg(args[i], XtNuseStringInPlace, FALSE); i++; */

  modify_text2 = XtCreateManagedWidget("modify_text2", asciiTextWidgetClass,
	modify_form, args, i);
}

/* -------------------------------------------------------------*/

	/**********************/
	/* Setenv Popup Shell */
	/**********************/
create_setenv_popup()
{
  int i;
  Arg args[20];

  setenv_cnt = NO_SETENV_CNT;
  setenv_str1 = NULL;
  setenv_str2 = NULL;

  i = 0;
  XtSetArg(args[i], XtNallowShellResize, FALSE); i++;
  setenv_pshell = XtCreateManagedWidget("setenv_pshell",
	transientShellWidgetClass, topLevel, args, i);

  setenv_form = XtCreateManagedWidget("setenv_form", formWidgetClass,
	setenv_pshell, args, 0);

  i=0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Cancel"); i++;
  setenv_cancel = XtCreateManagedWidget("setenv_cancel", commandWidgetClass,
	setenv_form, args, i);
  XtAddCallback(setenv_cancel, XtNcallback, SetenvCallback, 0);

  i=0;
  XtSetArg(args[i], XtNfromHoriz, setenv_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Setenv"); i++;
  setenv_ok = XtCreateManagedWidget("setenv_ok", commandWidgetClass,
	setenv_form, args, i);
  XtAddCallback(setenv_ok, XtNcallback, SetenvCallback, 1);

  i = 0;
  XtSetArg(args[i], XtNfromVert, setenv_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height+2); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable); i++;
  /* XtSetArg(args[i], XtNuseStringInPlace, FALSE); i++; */

  setenv_text1 = XtCreateManagedWidget("setenv_text1",
	asciiTextWidgetClass, setenv_form, args, i);

  i = 0;
  XtSetArg(args[i], XtNfromVert, setenv_text1); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable|scrollVertical); i++;
  /* XtSetArg(args[i], XtNuseStringInPlace, FALSE); i++; */

  setenv_text2 = XtCreateManagedWidget("setenv_text2", asciiTextWidgetClass,
	setenv_form, args, i);
}

/* -------------------------------------------------------------*/

	/*********************/
	/* Write Popup Shell */
	/*********************/
create_write_popup()
{
  int i;
  Arg args[20];

  i = 0;
  XtSetArg(args[i], XtNallowShellResize, FALSE); i++;
  write_pshell = XtCreateManagedWidget("write_pshell",
	transientShellWidgetClass, topLevel, args, i);

  write_form = XtCreateManagedWidget("write_form", formWidgetClass,
	write_pshell, args, 0);

  i=0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Cancel"); i++;
  write_cancel = XtCreateManagedWidget("write_cancel", commandWidgetClass,
	write_form, args, i);
  XtAddCallback(write_cancel, XtNcallback, WriteCallback, 0);

  i=0;
  XtSetArg(args[i], XtNfromHoriz, write_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Write"); i++;
  write_ok = XtCreateManagedWidget("write_ok",
	commandWidgetClass, write_form, args, i);
  XtAddCallback(write_ok, XtNcallback, WriteCallback, 1);

  i = 0;
  XtSetArg(args[i], XtNfromVert, write_cancel); i++;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextEdit); i++;
  XtSetArg(args[i], XtNtextOptions, editable); i++;
  /* XtSetArg(args[i], XtNuseStringInPlace, FALSE); i++; */

  write_text = XtCreateManagedWidget("write_text",
	asciiTextWidgetClass, write_form, args, i);
}

/* -------------------------------------------------------------*/

	/* A user has requested a message using the '}' */
create_message_popup(string)
char *string;
{
  int i;
  Arg args[20];
  Dimension height, width;
  int num_rets;
  char *command;
  Widget message_pshell, message_form, message_continue, message_text;
  message_struct *client_data;
  Position x_loc, y_loc;
  unsigned int scroll;

  query_location(&x_loc, &y_loc, 0);

  STR_CPY(command, string);

  num_rets = convert_str(command);

  num_rets++;

  if (num_rets > 10)
    {num_rets = 10;
    scroll = scrollVertical;}
  else
    {scroll = 0;}

  height = (num_rets+1) * switch_height + (4 * DEFAULT_DISTANCE);

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  message_pshell = XtCreateManagedWidget("message_pshell",
	transientShellWidgetClass, topLevel, args, i);

  client_data = (message_struct *) malloc(sizeof(message_struct));
  client_data->message_pshell = message_pshell;
  client_data->message_str = command;
  client_data->message_id = global_id;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  message_form = XtCreateManagedWidget("message_form", formWidgetClass,
	message_pshell, args, i);

  i = 0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  /* XtSetArg(args[i], XtNwidth, switch_width); i++; */
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Continue"); i++;
  message_continue = XtCreateManagedWidget("message_continue",
	commandWidgetClass, message_form, args, i);

  XtAddCallback(message_continue, XtNcallback, MessageContinueCallback, client_data);

  height = num_rets * switch_height;
  width = MAX_POPUP_WIDTH - (2*DEFAULT_DISTANCE);

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, width); i++;
  XtSetArg(args[i], XtNfromVert, message_continue); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextRead); i++;
  XtSetArg(args[i], XtNtextOptions, resizeWidth|scroll); i++;
  XtSetArg(args[i], XtNstring, command); i++;
  XtSetArg(args[i], XtNlength, strlen(command)); i++;
  XtSetArg(args[i], XtNuseStringInPlace, TRUE); i++;

  message_text = XtCreateManagedWidget("message_text", asciiTextWidgetClass,
	message_form, args, i);

  XtPopup(message_pshell, XtGrabNone);

  /* Don't FREE(command); */
}

/* -------------------------------------------------------------*/

	/* A user has requested a file using the ']' */
int
create_file_popup(string)
char *string;
{
  int i;
  Arg args[20];
  Dimension height, width;
  int num_rets;
  char *command;
  Widget file_pshell, file_form, file_continue, file_text;
  file_struct *client_data;
  Position x_loc, y_loc;
  unsigned int scroll;
  FILE *read_file;

  query_location(&x_loc, &y_loc, 0);

  STR_CPY(command, string);

  read_file = fopen(command, "r");

  if (read_file == NULL)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"File '%s' Not Found.",command);
    process_error(0);
    FREE(command);
    return(-1);}

  (void) fclose(read_file);

  num_rets = 10;
  scroll = scrollVertical;

  height = (num_rets+1) * switch_height + (4 * DEFAULT_DISTANCE);

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  file_pshell = XtCreateManagedWidget("file_pshell",
	transientShellWidgetClass, topLevel, args, i);

  client_data = (file_struct *) malloc(sizeof(file_struct));
  client_data->file_pshell = file_pshell;
  client_data->file_str = command;
  client_data->file_id = global_id;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  file_form = XtCreateManagedWidget("file_form", formWidgetClass,
	file_pshell, args, i);

  i = 0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  /* XtSetArg(args[i], XtNwidth, switch_width); i++; */
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Continue"); i++;
  file_continue = XtCreateManagedWidget("file_continue",
	commandWidgetClass, file_form, args, i);

  XtAddCallback(file_continue, XtNcallback, FileContinueCallback, client_data);

  height = num_rets * switch_height;
  width = MAX_POPUP_WIDTH - (2*DEFAULT_DISTANCE);

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, width); i++;
  XtSetArg(args[i], XtNfromVert, file_continue); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextRead); i++;
  XtSetArg(args[i], XtNtextOptions, resizeWidth|scroll); i++;
  XtSetArg(args[i], XtNfile, command); i++;
  /* XtSetArg(args[i], XtNstring, command); i++;
  XtSetArg(args[i], XtNlength, strlen(command)); i++;
  XtSetArg(args[i], XtNuseStringInPlace, TRUE); i++; */

  file_text = XtCreateManagedWidget("file_text", asciiDiskWidgetClass,
	file_form, args, i);

  XtPopup(file_pshell, XtGrabNone);

  /* Don't FREE(command); */

  return(0);
}

/* -------------------------------------------------------------*/

	/*********************/
	/* Error Popup Shell */
	/*********************/
create_error_popup()
{
  int i;
  Arg args[20];

  error_type = NO_ERROR_TYPE;

  error_pshell = XtCreateManagedWidget("error_pshell",
	transientShellWidgetClass, topLevel, args, 0);

  error_form = XtCreateManagedWidget("error_form", formWidgetClass,
	error_pshell, args, 0);

  i = 0;
  XtSetArg(args[i], XtNheight, switch_height); i++;
  /* XtSetArg(args[i], XtNwidth, switch_width); i++; */
  XtSetArg(args[i], XtNbottom, XtChainTop); i++;
  XtSetArg(args[i], XtNright, XtChainLeft); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNlabel, "Continue"); i++;

  error_continue = XtCreateManagedWidget("error_continue", commandWidgetClass,
	error_form, args, i);

  XtAddCallback(error_continue, XtNcallback, ErrorContinueCallback, 1);

  STRING_COPY(error_str,"");

  i = 0;
  XtSetArg(args[i], XtNfromVert, error_continue); i++;
  XtSetArg(args[i], XtNtop, XtChainTop); i++;
  XtSetArg(args[i], XtNleft, XtChainLeft); i++;
  XtSetArg(args[i], XtNbottom, XtChainBottom); i++;
  XtSetArg(args[i], XtNright, XtChainRight); i++;
  XtSetArg(args[i], XtNeditType, XttextRead); i++;
  XtSetArg(args[i], XtNtextOptions, resizeWidth); i++;
  XtSetArg(args[i], XtNstring, error_str); i++;
  XtSetArg(args[i], XtNlength, MAX_ERROR_LEN); i++;
  XtSetArg(args[i], XtNuseStringInPlace, TRUE); i++;

  error_text = XtCreateManagedWidget("error_text", asciiTextWidgetClass,
	error_form, args, i);
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static Boolean
convert_proc(w, selection, target, type_return, value_return,
	length_return, format_return)
Widget w;
Atom *selection;
Atom *target;
Atom *type_return;
caddr_t *value_return;
unsigned long *length_return;
int *format_return;
{
  char *command;
  char *data;

#ifdef DEBUG
  (void) printf("Convert Procedure Called\n");
#endif

  if (select_string == NULL)
    {
    command_currently = NOT_IN_PROGRESS;
    return(FALSE);
    }

  STR_CPY(command, select_string);

  (void) convert_str(command);

  if (*target == XA_STRING)
    {
#ifdef DEBUG
    (void) printf("Target is XA_STRING\n");
#endif

    *length_return = strlen(command);

    data = XtMalloc(*length_return);

    STRING_COPY(data,command);

    *value_return = data;

    *type_return = XA_STRING;

    *format_return = 8;

    FREE(command);

    return(TRUE);
    }

  FREE(command);

  command_currently = NOT_IN_PROGRESS;

  return(FALSE);
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
lose_ownership_proc(w, selection)
Widget w;
Atom *selection;
{
  int i;
  Arg args[5];

#ifdef DEBUG
  (void) printf("Lose Ownership Procedure Called\n");
#endif

  selection_owner = 0;

  if (selection_item != NO_SELECT)
    {
    i=0;
    XtSetArg(args[i], XtNbackground, White); i++;
    XtSetArg(args[i], XtNforeground, Black); i++;
    XtSetValues(switches[selection_item], args, i);
    }

  if (command_currently == IN_PROGRESS && command_send_event == 1)
    {
    command_currently = NOT_IN_PROGRESS;
    }
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
transfer_done_proc(w, selection, target)
Widget w;
Atom *selection;
Atom *target;
{
#ifdef DEBUG
  (void) printf("Transfer Done Procedure Called\n");
#endif

  CHECK1_COMMAND_IN_PROGRESS;
}

/* -------------------------------------------------------------*/

Boolean
own_selection()
{
	/* If a '!select' is requested but we are already the selection owner */
  if (selection_owner == 1)  return(TRUE);

  if (XtOwnSelection(topLevel,
	XA_PRIMARY,
	CurrentTime,
	convert_proc,
	lose_ownership_proc,
	transfer_done_proc) == FALSE)

    {XBell(dpy, 0);
    (void) sprintf(error_str,"ERROR: Failed to Become Selection Owner.\n");
    process_error(0);
    selection_owner = 0;
    return(FALSE);}

  else

    {selection_owner=1;

    return(TRUE);}
}

/* -------------------------------------------------------------*/

	/* Translate any \\ character sequence into a real backslash */
	/* Translate any \n character sequence into a real newline */
	/* Translate any \t character sequence into a real tab */
int
convert_str(string1)
char *string1;
{
  int x, y;
  char new_char;
  int len1;
  int num_rets;

  num_rets = 0;
  len1 = strlen(string1);
  for (x=0; x<len1-1; x++)
    {
    if (string1[x] == '\n')
      num_rets++;

    if (string1[x] == '\\')
      {
      new_char = '0';

		/* Regular \\ */
      if (string1[x+1] == '\\')
        new_char = '\\';

		/* New Lines */
      if (string1[x+1] == 'n')
        {
        new_char = '\n';
        num_rets++;
        }
		/* Tabs */
      if (string1[x+1] == 't')
        new_char = '\t';

      if (new_char != '0')
        {
        string1[x] = new_char;
        string1[x+1] = '\0';
        for (y=x+1; y<len1-1; y++)
          string1[y] = string1[y+1];
        len1--;
        string1[len1] = '\0';
        }
      }
    }
  return(num_rets);
}

/* -------------------------------------------------------------*/

/* ARGSUSED */
static void
switch_callback(widget, client_data, call_data)
Widget widget;
unsigned int client_data;
caddr_t call_data;
{
  char tmp_str[8];

  Position x_loc, y_loc;

#ifdef DEBUG
  (void) printf("Switch_Callback %d '%s' '%s'\n",client_data,
	switch_lab[client_data],switch_com[client_data]);
#endif

	/* Use if label_translations allows for input or
		keyboard tries to execute a label item */
  if (label_item[client_data] == 1) return;

	/* Too Long to respond to send_event command */
  if (command_currently == IN_PROGRESS && command_send_event == 1)
    {
    command_currently = NOT_IN_PROGRESS;
    }

  if (command_currently == NOT_IN_PROGRESS)
    {
	/* Get current pointer location */
    query_location(&x_loc, &y_loc, 1);

    (void) sprintf(tmp_str, "%d", x_loc);
    setenv_variable("X", tmp_str);

    (void) sprintf(tmp_str, "%d", y_loc);
    setenv_variable("Y", tmp_str);

    global_id++;
    if (global_id > 255) global_id = 0;
    switch_execution(client_data);
    }
  else
    {
    XBell(dpy, 0);
    (void) sprintf(error_str,"Command '%s' currently in progress.",
	command_string);
    process_error(0);
    }
}

/* -------------------------------------------------------------*/

	/* Replace each environment variable with its value */
char *
remove_vars(string1)
char *string1;
{
  int len1;
  int len2;

  int i, j, k;
  char *string2;
  char *string3;

  char *name;
  char *env_value;
  char *value;
  int len_value;

  len1 = strlen(string1);

  string2 = MALLOC_LEN(len1+1);
  string2[0] = '\0';

  len2 = len1;

  i = 0;
  j = 0;

  while (i < len1)
    {
    switch (string1[i])
      {
      case '$':
		/* Replace a '$$' with a '$' */
        if (string1[i+1] == '$')
          {
          string2[j] = string1[i];
          i+=2;
          j++;
          string2[j] = '\0';
          break;
          }

		/* Search for first non-alpha, '_', '{', or '}' character */
        for (k=i+1; k<len1; k++)
          if ((! isalnum(string1[k])) && (string1[k] != '_') &&
		(string1[k] != '{') && (string1[k] != '}'))
            break;

		/* If '$\0' then end */
        if (i==len1-1)
          {
          string2[j] = string1[i];
          i++;
          j++;
          string2[j] = '\0';
          break;
          }

		/* If '$[ \t\n]' don't touch */
        if (k==i+1)
          {
          string2[j] = string1[i];
          i++;
          j++;
          string2[j] = string1[i];
          i++;
          j++;
          string2[j] = '\0';
          break;
          }

        if (string1[i+1] == '{' && string1[k-1] == '}')
          {
          name = MALLOC_LEN(k-i-2);
          (void) strncpy(name, &string1[i+2], k-i-3);
          name[k-i-3] = '\0';
          }
        else
          {
          name = MALLOC_LEN(k-i);
          (void) strncpy(name, &string1[i+1], k-i-1);
          name[k-i-1] = '\0';
          }


#ifdef DEBUG
        printf("Environment Variable Name '%s'\n", name);
#endif

        env_value = getenv(name);
        if (env_value == NULL)
          {
          STR_CPY(value, "");
          }
        else
          {
          STR_CPY(value, env_value);
          }

        len_value = strlen(value);
        if (len_value+j >= len2)
          {
          len2 += len_value + 64;
          string3 = MALLOC_LEN(len2);
          STRING_COPY(string3, string2);
          FREE(string2);
          string2 = string3;
          }

#ifdef DEBUG
        printf("Environment Variable Value '%s'\n", value);
#endif

        (void) strcat(string2, value);

        FREE(name);
        FREE(value);
        i = k;
        j += len_value;
        break;

      default:
        string2[j] = string1[i];
        i++;
        j++;
        string2[j] = '\0';
        break;
      }
    }

  return(string2);
}

/* -------------------------------------------------------------*/

switch_execution(client_data)
unsigned int client_data;
{
  int i;
  Arg args[10];

  int valid;
  int quit_now;	/* Has return data been seen to allow a quit? */

  char *string1;/* Command String */
  int len1;	/* Command String Length */
  int done_flag;/* Done Processing Command String */
  int found;	/* Found the next separator character */
  int loc;	/* Begin next separator search at loc */
  char *string2;/* Command SubString */
  char *string3;/* Command SubString */
  int len3;	/* Command SubString Length */

  int cont_loop;	/* Continue Looping? */

  if (command_currently == NOT_IN_PROGRESS)
    {
    STR_CPY(string1, switch_com[client_data]);
    loc = 0;
    }
  else
    {
    string1 = command_string;
    loc = command_loc;
    }

  len1 = strlen(string1);

  quit_now = 0;

  done_flag = 0;

  cont_loop = 1;

#ifdef DEBUG
  printf("string1 = '%s', loc = %d\n", string1, loc);
#endif

  while (done_flag == 0 && cont_loop > 0)
    {
	/* Find position (loc) of next separator character */
    found = 0;
    for (i=loc; i<len1; i++)
      {
      if (string1[i] == separator_char)
        {found = 1;
        break;}
      }

	/* If found, use up to the separator character */
    if (found == 1)
      {
      string1[i] = '\0';
      STR_CPY(string3, &string1[loc]);
      string1[i] = '#';
      loc = i + 1;
      if (loc == len1)
        done_flag = 1;
      }
	/* Else, copy to the end of string1 */
    else
      {
      STR_CPY(string3, &string1[loc]);
      done_flag = 1;
      }

    len3 = strlen(string3);
    for (i=len3-1; i>=0; i++)
      {
      if (string3[i] != ' ')
        break;

      string3[i] = '\0';
      }

    len3 = strlen(string3);
    found = 0;
    for (i=0; i<len3; i++)
      {
      if (string3[i] != ' ')
        break;

      found = i+1;
      }

    STR_CPY(string2, &string3[found]);

    FREE(string3);

    if (string2[0] == substitution_char)
      {
      string3 = remove_vars(&string2[1]);
      FREE(string2);
      string2 = string3;
      }

    switch (string2[0])
      {
      case '!':
        valid=0;
        if (strcmp("!exit",string2)==0)
          exit(0);
        if (strcmp("!lower",string2)==0)
          {cont_loop = exec_request(LOWER_REQUEST); valid=1;}
        if (strcmp("!raise",string2)==0)
          {cont_loop = exec_request(RAISE_REQUEST); valid=1;}
        if (strcmp("!select",string2)==0)
          {
          cont_loop = exec_request(SELECT_REQUEST);
          valid=1;
          }
        if (strcmp("!delete",string2)==0)
          {cont_loop = exec_request(DELETE_REQUEST); valid=1;}
        if (strcmp("!print_item",string2)==0)
          {cont_loop = exec_request(PRINT_REQUEST); valid=1;}
        if (strcmp("!iconify",string2)==0)
          {cont_loop = exec_request(ICONIFY_REQUEST); valid=1;}
        if (strcmp("!modify",string2)==0)
          {if (modify_cnt == NO_MODIFY_CNT)
            {
            cont_loop = exec_request(MODIFY_REQUEST);
            }
          else
            {XBell(dpy, 0);
            (void) sprintf(error_str,"Only 1 Modify may take place at a time.");
            process_error(0);
            cont_loop = -1;}
          valid=1;}
        if (strncmp("!setenv",string2,7)==0)
          {cont_loop = setenv_command(string2);
          valid=1;}
        if (strcmp("!write_menu",string2)==0)
          {write_menu();
          cont_loop = 0;
          valid = 1;}
        if (strcmp("!read_menu",string2)==0)
          {read_menu();
          cont_loop = 0;
          valid = 1;}
        if (strcmp("!help",string2)==0)
          {create_message_popup(user_help);
          valid = 1;}
        if (strcmp("!print_menu",string2)==0)
          {print_menu(); valid=1;}
        if (strcmp("!insert",string2)==0)
          {cont_loop = insert_an_item();
          valid=1;}
        if (! valid)
          {
          XBell(dpy, 0);
          (void) sprintf(error_str,"'%s' Not Valid.  Commands: !exit,!raise,!lower,!select,!delete,!modify,!iconify.\n",string2);
          process_error(0);
          cont_loop = -1;
          }
        break;

      case '%':
        system_command(client_data, &string2[1]);
        break;

      case '>':
        if (selection == 0)
          {
          XBell(dpy, 0);
          (void) sprintf(error_str,"Window Not Selected.  Command '!select' is needed first.\n");
          process_error(0);
          cont_loop = -1;
          }
        else
          {
#ifdef DEBUG
          (void) printf("Window %d string '%s'\n",selection,string2);
#endif
          if (strcmp(">raise",string2)==0)
            {XRaiseWindow(dpy, select_child); break;}

          if (strcmp(">lower",string2)==0)
            {XLowerWindow(dpy, select_child); break;}

          if (strcmp(">iconify",string2)==0)
            {iconify_window(select_child); break;}

          if (strcmp(">deiconify",string2)==0)
            {XMapWindow(dpy, select_child); break;}

		/* Get to be the owner of the primary selection */
          if (own_selection() == FALSE)
            {cont_loop = -1;
            break;}

		/* Unhighlight old selection and highlight new one */
          if (app_data.highlight)
            {
            if (selection_item != NO_SELECT &&
		selection_item != client_data)
              {
              i=0;
              XtSetArg(args[i], XtNbackground, White); i++;
              XtSetArg(args[i], XtNforeground, Black); i++;
              XtSetValues(switches[selection_item], args, i);
              }

		/* Highlight the new selection item */
            selection_item = client_data;
            i=0;
            XtSetArg(args[i], XtNbackground, Black); i++;
            XtSetArg(args[i], XtNforeground, White); i++;
            XtSetValues(switches[selection_item], args, i);
            }

          FREE(select_string);

          STR_CPY(select_string, &string2[1]);

#ifdef DEBUG
          (void) printf("Sending Button Release Event...\n");
#endif
          button_event.xbutton.type	= ButtonRelease;
          button_event.xbutton.send_event	= True;
          button_event.xbutton.time	= CurrentTime;
          button_event.xbutton.state	= button_state;
          XSendEvent(dpy,
		button_event.xbutton.window,
		True,
		None,
		&button_event);
#ifdef DEBUG
          (void) printf("Sent Button Event\n");
#endif

          cont_loop = -2;
          }
        break;

      case '}':
        create_message_popup(&string2[1]);
        cont_loop = 0;
        break;

      case ']':
        cont_loop = create_file_popup(&string2[1]);
        break;

      default:
        (void) printf("%s\n",string2);
        /* (void) printf("%s",string2); */
        quit_now = 1;
        break;
      }

    FREE(string2);

    }

	/* Loop was broken because of a popup command in progress */
		/* or */
	/* Loop was broken because of a target window send event */
    if (done_flag == 0 && (cont_loop == 0 || cont_loop == -2))
      {
      command_currently = IN_PROGRESS;
      command_item = client_data;
      command_loc = loc;
      command_string = string1;
      command_id = global_id;
      if (cont_loop == 0)
        command_send_event = 0;
      else
        command_send_event = 1;
      }
    else
      {
      command_currently = NOT_IN_PROGRESS;
      FREE(string1);
      }

    if (quit_now == 1 && app_data.noquit == FALSE) exit(0);
}

/* -------------------------------------------------------------*/

system_command(item, string)
unsigned int item;
char *string;
{
  char *command;

  STR_CPY(command, string);

	/* Translate '\n' characters into real newlines */
  (void) convert_str(command);

#ifdef DEBUG
  (void) printf("switch_com[%d]='%s'\n",item,switch_com[item]);
  (void) printf("command='%s'\n",command);
#endif

  setenv_variable("ITEM", switch_lab[item]);
  setenv_variable("OCMD", switch_com[item]);
  setenv_variable("CMD", command);

  (void) system(command);

  FREE(command);
}

/* -------------------------------------------------------------*/

iconify_window(child)
Window child;
{
  XEvent iconify_event;

	/* From FAQ_X4 [Subject 111] April 2, 1991 */
  iconify_event.type = ClientMessage;
  iconify_event.xclient.send_event = True;
  iconify_event.xclient.display = dpy;
  iconify_event.xclient.window = child;
  iconify_event.xclient.message_type =
	XInternAtom(dpy, "WM_CHANGE_STATE", False);
  iconify_event.xclient.format = 32;
  iconify_event.xclient.data.l[0] = IconicState;
  XSendEvent(dpy, Root_Window, False,
	SubstructureRedirectMask | SubstructureNotifyMask,
	&iconify_event);
  XFlush(dpy);
}

/* -------------------------------------------------------------*/

int
exec_request(request_id)
int request_id;
/*
	LOWER_REQUEST			Lower
	RAISE_REQUEST			Raise
	SELECT_REQUEST			Select
	DELETE_REQUEST			Delete
	PRINT_REQUEST			Print
	ICONIFY_REQUEST			Iconify
	MODIFY_REQUEST			Modify
	SELECT_KEY_REQUEST		Select Item requested from Keyboard
	DELETE_KEY_REQUEST		Delete Item requested from Keyboard
	MODIFY_KEY_REQUEST		Modify Item requested from Keyboard
	POINTER_UP_KEY_REQUEST		Pointer Up requested from keyboard
	POINTER_DOWN_KEY_REQUEST	Pointer Down requested from keyboard
	EXECUTE_ITEM_KEY_REQUEST	Execute Current Item from keyboard
*/
{
  XEvent xevent;
  int done;

  int retval;

  Window root, child;
  Window newchild;
  int rootx, rooty;
  int winx, winy;
  unsigned int keys_buttons;

  int x, y, found;
  Cursor cursor;

  int wait;

  wait = 1;
  switch (request_id) {
    case LOWER_REQUEST:
    case RAISE_REQUEST:
    case ICONIFY_REQUEST:
      cursor = cursor_dot;
      break;
    case SELECT_REQUEST:
    case SELECT_KEY_REQUEST:
      cursor = cursor_middle_button;
      break;
    case DELETE_REQUEST:
      cursor = cursor_skull;
      break;
    case PRINT_REQUEST:
    case MODIFY_REQUEST:
      cursor = cursor_hand;
      break;
    case DELETE_KEY_REQUEST:
    case MODIFY_KEY_REQUEST:
    case POINTER_UP_KEY_REQUEST:
    case POINTER_DOWN_KEY_REQUEST:
    case EXECUTE_ITEM_KEY_REQUEST:
      wait = 0;
      break;
  }

/* When user requests from keyboard don't wait for button press */
  if (wait)
    {
    XGrabPointer(dpy,
	Top_Window,
	True,					/* Owner Events */
	ButtonReleaseMask,			/* Event Mask */
	GrabModeAsync,				/* Pointer Mode */
	GrabModeAsync,				/* Keyboard Mode */
	None,					/* Confine_To */
	cursor,					/* Cursor */
	CurrentTime);				/* Time */

    /* XMaskEvent(dpy,ButtonReleaseMask,&xevent); */
    done = 0;
    while (! done)
      {
      XtNextEvent(&xevent);
      if (xevent.type == ButtonRelease)
        done = 1;
      else
        if (xevent.type != KeyPress && xevent.type != KeyRelease &&
		xevent.type != ButtonPress)
          XtDispatchEvent(xevent);
      }

#ifdef DEBUG
  (void) printf("This window %d; This root window %d\n",Top_Window,
	Root_Window);
  (void) printf("MaskEvent button event window=%d, root=%d, subwindow=%d\n",
	xevent.xbutton.window, xevent.xbutton.root,
	xevent.xbutton.subwindow);
#endif
    }

  XQueryPointer(dpy,
	Root_Window,
	&root,
	&child,
	&rootx, &rooty,
	&winx, &winy,
	&keys_buttons);

	/* Virtual Desktop Requires window 1 more further down */
  /* if (app_data.tvtwm && child != 0)
    {
    newchild = child;

    XQueryPointer(dpy,
	newchild,
	&root,
	&child,
	&rootx, &rooty,
	&winx, &winy,
	&keys_buttons);
    } */

#ifdef DEBUG
  (void) printf("Query root=%d, child=%d\n",root,child);
  (void) printf("rootx=%d rooty=%d  winx=%d winy=%d\n",rootx,rooty,winx,winy);
#endif

  retval = 1;

  if (child != 0)
    {
    switch (request_id)
      {
      case LOWER_REQUEST:
        XLowerWindow(dpy, child);
        break;

      case RAISE_REQUEST:
        XRaiseWindow(dpy, child);
        break;

      case SELECT_REQUEST:
      case SELECT_KEY_REQUEST:
        select_child = child;

	/* Continue down until lowest child is found */
        while (child != 0)
          {
          newchild = child;

          XQueryPointer(dpy,
	      newchild,
	      &root,
	      &child,
	      &rootx, &rooty,
	      &winx, &winy,
	      &keys_buttons);
          }
        selection = newchild;
	/* selection = child; */

	button_event.xbutton.display	= dpy;
	button_event.xbutton.window	= selection;
	button_event.xbutton.root	= root;
	button_event.xbutton.subwindow	= 0;
	button_event.xbutton.x		= winx;
	button_event.xbutton.y		= winy;
	button_event.xbutton.x_root	= rootx;
	button_event.xbutton.y_root	= rooty;

	/* button_event.xbutton.display	= xevent.xbutton.display;
	button_event.xbutton.window	= selection;
	button_event.xbutton.root	= xevent.xbutton.root;
	button_event.xbutton.subwindow	= xevent.xbutton.subwindow;
	button_event.xbutton.x		= xevent.xbutton.x;
	button_event.xbutton.y		= xevent.xbutton.y;
	button_event.xbutton.x_root	= xevent.xbutton.x_root;
	button_event.xbutton.y_root	= xevent.xbutton.y_root; */

	button_state			= xevent.xbutton.state;
	button_event.xbutton.button	= xevent.xbutton.button;
	button_event.xbutton.same_screen	= xevent.xbutton.same_screen;

#ifdef DEBUG
	(void) printf("window=%d winx=%d winy=%d rootx=%d rooty=%d\n",
		button_event.xbutton.window,winx,winy,rootx,rooty);
	(void) printf("button=%d\n",button_event.xbutton.button);
#endif
        break;

      case DELETE_REQUEST:
      case DELETE_KEY_REQUEST:
      case PRINT_REQUEST:
      case MODIFY_REQUEST:
      case MODIFY_KEY_REQUEST:
      case POINTER_UP_KEY_REQUEST:
      case POINTER_DOWN_KEY_REQUEST:
      case EXECUTE_ITEM_KEY_REQUEST:
	/* Continue down until lowest child is found */
        while (child != 0)
          {
          newchild = child;

          XQueryPointer(dpy,
	      newchild,
	      &root,
	      &child,
	      &rootx, &rooty,
	      &winx, &winy,
	      &keys_buttons);
          }

        found = -1;
        for (x=0; x<max_switches; x++)
          {
          y = lookup[x];
          if (newchild == XtWindow(switches[y]))
            {found = y;
            break;}
          }

        if (found == -1)
          {
          XBell(dpy, 0);
          /* (void) sprintf(error_str,"A Menu Button was not chosen.");
          process_error(0); */
          retval = -1;
          }
        else
          {
          switch (request_id)
            {
            case DELETE_REQUEST:
            case DELETE_KEY_REQUEST:
              if (x == max_switches-1)
                move_pointer_up(x);
              delete_switch(x);
              break;

            case PRINT_REQUEST:
              print_item(stdout, found);
              break;

            case MODIFY_REQUEST:
            case MODIFY_KEY_REQUEST:
              modify_menu_item(found);
              retval = 0;
              break;

            case POINTER_UP_KEY_REQUEST:
              move_pointer_up(x);
              break;

            case POINTER_DOWN_KEY_REQUEST:
              move_pointer_down(x);
              break;

            case EXECUTE_ITEM_KEY_REQUEST:
              switch_callback(switches[found], (unsigned int)found,
		(caddr_t)NULL);
              break;
            }
          }

        break;

      case ICONIFY_REQUEST:
        iconify_window(child);
        break;
      }
    }
  else
    {
    XBell(dpy, 0);
    /* if (request_id == SELECT_REQUEST || request_id == SELECT_KEY_REQUEST)
      {
      (void) sprintf(error_str,"A Proper Window was NOT Selected.");
      process_error(0);
      } */
    retval = -1;
    }

  XUngrabPointer(dpy, CurrentTime);

  return(retval);
}

/* -------------------------------------------------------------*/

	/* Add a backslash newline character sequence after
		every \n character sequence */
static char *
convert_before_modify(string1)
char *string1;
{
  int i, j;
  int len1, len2;
  int cnt;
  char *string2;
  int backslash;

  len1 = strlen(string1);

	/* Determine count of '\n' character sequences so an actual
		backslash newline may be added */
  backslash = 0;
  cnt = 0;
  for (i=0; i<len1-1; i++)
    {
    if (string1[i] == '\\')
      {
      if (backslash == 1)
        backslash = 0;
      else
        backslash = 1;
      continue;
      }
    if (string1[i] == 'n' && backslash)
      {
      cnt += 2;
      }
    backslash = 0;
    }

  len2 = len1 + cnt + 1;
  string2 = MALLOC_LEN(len2);

  backslash = 0;
  j = 0;
  for (i=0; i<len1-1; i++)
    {
    string2[j] = string1[i];
    j++;

    if (string1[i] == '\\')
      {
      if (backslash == 1)
        backslash = 0;
      else
        backslash = 1;
      continue;
      }

    if (string1[i] == 'n' && backslash)
      {
      string2[j++] = '\\';
      string2[j++] = '\n';
      }
    backslash = 0;
    }

  if (len1 > 0)
    string2[len2-2] = string1[len1-1];

  string2[len2-1] = '\0';
  return(string2);
}

/* -------------------------------------------------------------*/

	/* Pull any backslash newline character sequences */
static char *
convert_after_modify(string1)
char *string1;
{
  int i, j;
  int len1, len2;
  int cnt;
  char *string2;

  len1 = strlen(string1);

	/* Determine count of backslash newline character sequences
		so they may be removed */
  cnt = 0;
  for (i=0; i<len1-1; i++)
    {
    if (string1[i] == '\\' && string1[i+1] == '\n')
      cnt+=2;
    }

  len2 = len1 - cnt + 1;
  string2 = MALLOC_LEN(len2);

  j = 0;
  for (i=0; i<len1-1; i++)
    {
    if (string1[i] == '\\' && string1[i+1] == '\n')
      {
      i++;
      continue;
      }
    string2[j] = string1[i];
    j++;
    }

  if (len1 > 0)
    string2[len2-2] = string1[len1-1];

  string2[len2-1] = '\0';
  return(string2);
}

/* -------------------------------------------------------------*/

print_item(fp, item)
FILE *fp;
int item;
{
  int i;
  int len1;
  char string1[MAX_SWITCH_LAB+1];
  int next_chance;
  char switch_num[5];

  STRING_COPY(string1,switch_lab[item]);
  len1 = strlen(string1);

  string1[len1] = '"';
  string1[len1+1] = '\0';

  (void) fprintf(fp,"\"%-20s\t",string1);

  (void) sprintf(switch_num,"%d",item+1);

  if (strcmp(switch_num, switch_com[item]) != 0)
    {
    len1 = strlen(switch_com[item]);

    next_chance = 0;

    for (i=0; i<len1; i++)
      {
      if (next_chance == 1 &&
	  (switch_com[item][i] != ' ' && switch_com[item][i] != '\t'))
        {
        next_chance = 0;
        (void) fprintf(fp,"\\\n");
        }

      if (i != 0 && switch_com[item][i] == 'n' &&
	  switch_com[item][i-1] == '\\' && i != len1-1)
        {
        if (switch_com[item][i+1] == ' ' || switch_com[item][i+1] == '\t')
          {
          next_chance = 1;
          (void) fprintf(fp,"%c",switch_com[item][i]);
          }
        else
          (void) fprintf(fp,"n\\\n");
        }
      else
        if (switch_com[item][i] == '\n')
          {
          next_chance = 1;
          (void) fprintf(fp,"\\n");
          }
        else
          (void) fprintf(fp,"%c",switch_com[item][i]);
      }
    }

  (void) fprintf(fp,"\n");
}

/* -------------------------------------------------------------*/

static void
print_menu()
{
  int x, y;

  for (x=0; x<max_switches; x++)
    {
    y = lookup[x];
    print_item(stdout, y);
    }
}

/* -------------------------------------------------------------*/

	/* Setup the Switches */
setup_switches(parent)
Widget parent;
{
  int i;
  Arg args[20];

  Dimension new_width, new_height;

  char name[20];

  int x;

  int num;

  switch_width = 0;
  switch_height = 0;

  num = 0;
  for (x=0; x<max_switches; x++)
     {
       alive[x] = 1;
       lookup[x] = x;

       (void) sprintf(name,"switch_%d\0",num);

       i=0;

       XtSetArg(args[i], XtNlabel, switch_lab[num]); i++;
       XtSetArg(args[i], XtNjustify, XtJustifyCenter); i++;
       XtSetArg(args[i], XtNsensitive, TRUE); i++;

       if (strcmp(switch_com[x],"!label") == 0)
         {
         XtSetArg(args[i], XtNborderColor, White); i++;
         XtSetArg(args[i], XtNhighlightThickness, 0); i++;
         XtSetArg(args[i], XtNtranslations, switch_label_translations); i++;
         label_item[x] = 1;
         }
       else
         {
         XtSetArg(args[i], XtNborderColor, Black); i++;
         XtSetArg(args[i], XtNhighlightThickness, 1); i++;
         XtSetArg(args[i], XtNtranslations, switch_command_translations); i++;
         label_item[x] = 0;
         }

       switches[x] = XtCreateManagedWidget(name, commandWidgetClass,
	     parent, args, i);

       XtAddCallback(switches[x], XtNcallback, switch_callback, num);

       i=0;
       XtSetArg(args[i], XtNheight, &new_height); i++;
       XtSetArg(args[i], XtNwidth,  &new_width); i++;
       XtGetValues(switches[x], args, i);

       if (new_width > switch_width) switch_width = new_width;
       if (new_height > switch_height) switch_height = new_height;

       num++;
     }

  for (x=0; x<max_switches; x++)
    {
    i=0;
    XtSetArg(args[i], XtNheight, switch_height); i++;
    XtSetArg(args[i], XtNwidth,  switch_width); i++;
    /* XtSetArg(args[i], XtNresizable,  FALSE); i++; */
    XtSetValues(switches[x], args, i);
    }

  if (app_data.horizontal)
    {
    new_width = num*(switch_width+X_SPACE+2);
    new_height = switch_height+Y_SPACE;
    }
  else
    {
    new_width = switch_width+X_SPACE+2;
    new_height = num*(switch_height+Y_SPACE);
    }

  i = 0;
  XtSetArg(args[i], XtNwidth,  new_width); i++;
  XtSetArg(args[i], XtNheight, new_height); i++;
  XtSetValues(parent, args, i);

  for (x=max_switches; x<MAX_SWITCHES; x++)
    {
    alive[x] = 0;
    lookup[x] = -1;
    }
}

/* -------------------------------------------------------------*/

delete_switch(destroy)
int destroy;
{
  int i;
  Arg args[5];
  int x, y;
  Dimension box_height, box_width;
  Dimension top_height, top_width;
  XSizeHints size_hints;

  y = lookup[destroy];

	/* User is deleting a currently modified switch */
  if (modify_cnt != NO_MODIFY_CNT && modify_cnt-1 == y)
    {
    XBell(dpy, 0);
    (void) sprintf(error_str,"You may not delete a switch while it's being modified.\n");
    process_error(0);
    return;
    }

  alive[y] = 0;

  FREE(switch_com[y]);

  i=0;
  XtSetArg(args[i], XtNheight, &top_height); i++;
  XtSetArg(args[i], XtNwidth, &top_width); i++;
  XtGetValues(topLevel, args, i);

  i=0;
  XtSetArg(args[i], XtNheight, &box_height); i++;
  XtSetArg(args[i], XtNwidth, &box_width); i++;
  XtGetValues(switchbox, args, i);

  if (app_data.horizontal)
    {
    box_width -= (switch_width+X_SPACE);
    top_width -= (switch_width+X_SPACE);
    }
  else
    {
    box_height -= (switch_height+Y_SPACE);
    top_height -= (switch_height+Y_SPACE);
    }

  XtDestroyWidget(switches[lookup[destroy]]);

  for (x=destroy; x<max_switches-1; x++)
    {
    lookup[x] = lookup[x+1];
    }
  lookup[x] = -1;

  max_switches--;

  if (max_switches == 0) exit(0);

  i=0;
  XtSetArg(args[i], XtNheight, box_height); i++;
  XtSetArg(args[i], XtNwidth, box_width); i++;
  XtSetValues(switchbox, args, i); 

  i=0;
  XtSetArg(args[i], XtNheight, top_height); i++;
  XtSetArg(args[i], XtNwidth, top_width); i++;
  XtSetValues(topLevel, args, i);

  size_hints.min_width  = top_width;
  size_hints.min_height = top_height;
  size_hints.max_width  = top_width;
  size_hints.max_height = top_height;
  size_hints.flags = PMinSize | PMaxSize;
  XSetNormalHints(dpy, Top_Window, &size_hints);

#ifdef DEBUG
  for (x=0; x<max_switches; x++)
    {
    (void) printf("Delete lookup[%d]=%d, alive[lookup[%d]]=%d\n",
	x,lookup[x],x,alive[lookup[x]]);
    }
#endif

	/* Reset the selection item if destroying the selection item */
  if (y == selection_item)
    {
    selection_item = NO_SELECT;
    /* Should we now become 'disowner' and/or free the select_string? */
    }
}

/* -------------------------------------------------------------*/

	/* Get the current pointer position relative to the
		topLevel Window */
query_position(x, y)
Position *x;
Position *y;
{
  Window toplevel, child;
  int toplevelx, toplevely;
  int winx, winy;
  unsigned int keys_buttons;

  XQueryPointer(dpy,
	Top_Window,
	&toplevel,
	&child,
	&toplevelx, &toplevely,
	&winx, &winy,
	&keys_buttons);

  *x = winx;
  *y = winy;
}

/* -------------------------------------------------------------*/

	/* Get the current pointer location either absolute
		location or relative to the Root_Window */
query_location(x, y, relative)
Position *x;
Position *y;
int relative;	/* 0=absolute location, 1=relative location */
{
  Window root, child;
  int rootx, rooty;
  int winx, winy;
  unsigned int keys_buttons;

  int vir_rootx, vir_rooty;
  Window vir_child;

	/* Should we keep the origin the same as before? */
  if (command_currently != NOT_IN_PROGRESS)
    {
    *x = x_loc_old;
    *y = y_loc_old;
    return;
    }

  XQueryPointer(dpy,
	Root_Window,
	&root,
	&child,
	&rootx, &rooty,
	&winx, &winy,
	&keys_buttons);

  if (app_data.tvtwm && relative)
    {
    XTranslateCoordinates(dpy,
	root,
	Root_Window,
	rootx, rooty,
	&vir_rootx, &vir_rooty,
	&vir_child);
    *x = vir_rootx;
    *y = vir_rooty;
    }
  else
    {
    *x = rootx;
    *y = rooty;
    }

  x_loc_old = *x;
  y_loc_old = *y;
}

/* -------------------------------------------------------------*/

int
read_menu_file(fp)
FILE *fp;
{
  int i, j, x, y;
  char *string1;
  char string2[MAX_STRING];
  char *string3;
  int len1, len2, maxlen1;
  int separator_ws;	/* 0=White Space, 1=Double Quote */
  int done_flag, found;
  int cnt;
  int strmode;		/* Destroy/Preserve last 2 characters of line */

  cnt = 0;

  maxlen1 = MAX_STRING;
  string1 = MALLOC_LEN(maxlen1+1);

  while ((fgets(string1,maxlen1,fp) != NULL) && (cnt < MAX_SWITCHES))
    {
    len1 = strlen(string1);

#ifdef DEBUG
    printf("read_menu_file: string1 [%d] '%s'\n", len1, string1);
#endif

	/* Find first non-white space character */
    for (i=0; i<len1; i++)
      if (string1[i] != ' ' && string1[i] != '\t')
        break;

	/* Ignore Blank Lines and Comments */
    if (i == len1 || string1[i] == '#' || string1[i] == '\n') continue;

	/* Ignore Just \ eof */
    if (i == len1-1 && string1[i] == '\\') continue;

	/* Ignore \ eol */
    if (i == len1-2 && string1[i] == '\\' && string1[i+1] == '\n') continue;

    strmode = 0;
	/* String ends in \,\n character sequence */
    if (string1[len1-2] == '\\' && string1[len1-1] == '\n')
      strmode = 1;
	/* One line string cannot fit into maxlen characters */
    if (len1 == maxlen1-1 && string1[len1-1] != '\n')
      strmode = 2;

    if (strmode > 0)
      {
      done_flag = 0;
      while (!done_flag)
        {
        if (fgets(string2,MAX_STRING,fp) != NULL)
          {
          len2 = strlen(string2);

          if (len1+len2 > maxlen1)
            {maxlen1 += MAX_STRING;
            string3 = MALLOC_LEN(maxlen1+1);
            STRING_COPY(string3,string1);
            FREE(string1);
            string1 = string3;}

          for (j=0; j<len2; j++)
            if (string2[j] != ' ' && string2[j] != '\t')
              break;

		/* Ignore Blank Lines and Comments */
          if (j == len2 || string2[j] == '#' || string2[j] == '\n') continue;

		/* Ignore Just \ eof */
          if (j == len2-1 && string2[j] == '\\') continue;

		/* Ignore \ eol */
          if (j == len2-2 && string2[j] == '\\' && string2[j+1] == '\n') continue;

		/* Copy removing last 2 characters */
          if (strmode == 1)
            {
            STRING_COPY(&string1[len1-2], &string2[j]);

            len1 += (len2-j-2);
            }
          else
		/* Copy preserving last 2 characters */
            {
            STRING_COPY(&string1[len1], &string2[j]);

            len1 += (len2-j);
            }

          strmode = 0;

		/* String ends in \,\n character sequence */
          if (string2[len2-2] == '\\' && string2[len2-1] == '\n')
            strmode = 1;

		/* One line string cannot fit into maxlen characters */
          if (len2 == MAX_STRING-1 && string2[len2-1] != '\n')
            strmode = 2;

          if (strmode == 0)
            done_flag = 1;

#ifdef DEBUG
          (void) printf("string1 (%d) = '%s'\n",strlen(string1),string1);
          (void) printf("string2 (%d) = '%s'\n",strlen(string2),string2);
          (void) printf("len1 = %d, len2 = %d\n",len1,len2);
#endif
          }
        else
          done_flag = 1;
        }
      }

#ifdef DEBUG
    (void) printf("STRING1 (%d) = '%s'\n",strlen(string1),string1);
    (void) printf("LEN1 = %d\n",len1);
#endif

	/* Remove New Line */
    if (string1[len1-1] == '\n')
      {
      len1--;
      string1[len1] = '\0';
      }

    if (string1[i] != '"')
      separator_ws = 0;
    else 
      separator_ws = 1;

    found = 0;
    for (x=i+1; x<len1; x++)
      {
      if (separator_ws == 0)
        if (string1[x] == ' ' || string1[x] == '\t')
          {
          string1[x] = '\0';
          for (y=x+1; y<len1; y++)
            if (string1[y] != ' ' && string1[y] != '\t')
              break;
          if (y != len1)
            found = 1;
          break;
          }

      if (separator_ws == 1)
        if (string1[x] == '"')
          {
          string1[x] = '\0';
          for (y=x+1; y<len1; y++)
            if (string1[y] != ' ' && string1[y] != '\t')
              break;
          if (y != len1)
            found = 1;
          break;
          }
      }

    if (separator_ws == 1)
      i++;

    if (strlen(&string1[i]) > MAX_SWITCH_LAB)
      {
      (void) printf("Switch Label Length of %d larger than %d ('%s').\n",strlen(&string1[i]),MAX_SWITCH_LAB,&string1[i]);
      continue;
      }

    STRING_COPY(switch_lab[cnt],&string1[i]);

    if (!found)
      {
      switch_com[cnt] = MALLOC_LEN(5);
      (void) sprintf(switch_com[cnt],"%d",cnt+1);
      }
    else
      {
      STR_CPY(switch_com[cnt], &string1[y]);
      }

#ifdef DEBUG
    (void) printf("String1 = %d:'%s'\n",strlen(switch_lab[cnt]),switch_lab[cnt]);
    (void) printf("String2 = %d:'%s'\n",strlen(switch_com[cnt]),switch_com[cnt]);
#endif

    cnt++;
    }

	/* Read to EOF for switches > MAX_SWITCHES */
  if (fgets(string1,maxlen1,fp) != NULL)
    {
    (void) fprintf(stderr,
	"Maximum number of menu items '%d' -- rest discarded.\n", MAX_SWITCHES);
    while (fgets(string1,maxlen1,fp) != NULL) ;
    }

  FREE(string1);

  return(cnt);
}

/* -------------------------------------------------------------*/

process_error(cnt)
int cnt;
{
  int i;
  Arg args[10];
  Position x_loc, y_loc;
  Dimension height;

  if (cnt > 0)
    {
    i = 0;
    XtSetArg(args[i], XtNfromHoriz, error_continue); i++;
    XtSetArg(args[i], XtNheight, switch_height); i++;
    /* XtSetArg(args[i], XtNwidth, switch_width); i++; */
    XtSetArg(args[i], XtNbottom, XtChainTop); i++;
    XtSetArg(args[i], XtNright, XtChainLeft); i++;
    XtSetArg(args[i], XtNleft, XtChainLeft); i++;
    XtSetArg(args[i], XtNtop, XtChainTop); i++;
    XtSetArg(args[i], XtNlabel, error_extra_str[0]); i++;

    error_extra[0] = XtCreateManagedWidget("error_extra_0",
	commandWidgetClass, error_form, args, i);

    XtAddCallback(error_extra[0], XtNcallback,
	ErrorContinueCallback, 2);
    }

  if (cnt > 1)
    {
    i = 0;
    XtSetArg(args[i], XtNfromHoriz, error_extra[0]); i++;
    XtSetArg(args[i], XtNheight, switch_height); i++;
    /* XtSetArg(args[i], XtNwidth, switch_width); i++; */
    XtSetArg(args[i], XtNbottom, XtChainTop); i++;
    XtSetArg(args[i], XtNright, XtChainLeft); i++;
    XtSetArg(args[i], XtNleft, XtChainLeft); i++;
    XtSetArg(args[i], XtNtop, XtChainTop); i++;
    XtSetArg(args[i], XtNlabel, error_extra_str[1]); i++;

    error_extra[1] = XtCreateManagedWidget("error_extra_1",
	commandWidgetClass, error_form, args, i);

    XtAddCallback(error_extra[1], XtNcallback,
	ErrorContinueCallback, 3);
    }

  query_location(&x_loc, &y_loc, 0);

  i = 0;
  XtSetArg(args[i], XtNstring, error_str); i++;
  XtSetValues(error_text, args, i);

  height = 2*(switch_height+Y_SPACE) + Y_SPACE;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  XtSetValues(error_pshell, args, i);

  XtPopup(error_pshell, XtGrabNonexclusive);
}

/* -------------------------------------------------------------*/

static void
insert_item()
{
  (void) insert_an_item();
}

/* -------------------------------------------------------------*/

int
insert_an_item()
{
  int i;
  Arg args[10];
  Position x_loc, y_loc;
  Dimension height;

  if (insert_cnt != NO_INSERT_CNT)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"Only 1 Insert may take place at a time.");
    process_error(0);
    return(-1);}

  if (max_switches == MAX_SWITCHES)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"No more room in menu to add.\n");
    process_error(0);
    return(-1);}

  insert_cnt = 1;

  query_location(&x_loc, &y_loc, 0);

  height = (12) * switch_height + (4*DEFAULT_DISTANCE);

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, MAX_POPUP_WIDTH); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  XtSetValues(insert_pshell, args, i);

  XtPopup(insert_pshell, XtGrabNone);

  return(0);
}

/* -------------------------------------------------------------*/

modify_menu_item(item)
int item;
{
  int i;
  Arg args[10];
  Position x_loc, y_loc;
  Dimension height, width;

  modify_cnt = item+1;

  query_location(&x_loc, &y_loc, 0);

  modify_str1 = &switch_lab[item][0];
  modify_str2 = convert_before_modify(switch_com[item]);

#ifdef DEBUG
  (void) printf("Modify Item %d, Label '%s', Command '%s'\n",
	item, modify_str1, modify_str2);
#endif

  i = 0;
  XtSetArg(args[i], XtNstring, modify_str1); i++;
  XtSetValues(modify_text1, args, i);

  i = 0;
  XtSetArg(args[i], XtNstring, modify_str2); i++;
  XtSetValues(modify_text2, args, i);

  height = (12) * switch_height + (4*DEFAULT_DISTANCE);
  width = MAX_POPUP_WIDTH;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, width); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  XtSetValues(modify_pshell, args, i);

  XtPopup(modify_pshell, XtGrabNone);

  FREE(modify_str2);
}

/* -------------------------------------------------------------*/

#define OPEN_MODE	((6<<6)|(4<<3)|(4))
/* #define UMASK		((2<<3)|(2)) */

char *
backquote(command)
char *command;
{
  char *name;

  int old_stdout;
  int file;

  FILE *fileptr;
  int c;
  int i;

  char *retstr;
  int len;
  int maxlen;
  char *newstr;
  char *dir;

	/*--------------------------------*/

  dir = NULL;

  name = tempnam(dir,"xtmenu");

  if (name == NULL)
    {
    (void) fprintf(stderr,"Couldn't allocate temporary filename correctly.\n");
    return(NULL);
    }

#ifdef DEBUG
  printf("Using File '%s'\n", name);
#endif

  /* umask(UMASK); */

  file = open(name, O_WRONLY | O_CREAT | O_TRUNC, OPEN_MODE);

  old_stdout = dup(1);

  (void) dup2(file, 1);

	/* Translate '\n' characters into real newlines */
  (void) convert_str(command);

  (void) system(command);

  (void) dup2(old_stdout, 1);

  (void) close(file);

  (void) close(old_stdout);


	/*--------------------------------*/

  maxlen = 127;
  len = 0;
  retstr = MALLOC_LEN(maxlen+1);
  retstr[len] = '\0';

  fileptr = fopen(name, "r");

  while ((c=fgetc(fileptr)) != EOF)
    {
    if (len > maxlen)
      {
      maxlen += 128;
      newstr = MALLOC_LEN(maxlen+1);
      STRING_COPY(newstr, retstr);
      FREE(retstr);
      retstr = newstr;
      }

    /* if (c == '\n') c = ' '; */

    if (c != '\n')
      {
      if (c < '\040' || c > '\176')
        continue;
      }

    retstr[len] = (char) c;
    len++;
    retstr[len] = '\0';
    }

  (void) fclose(fileptr);

	/*--------------------------------*/

  (void) unlink(name);

  FREE(name);

	/* Remove any trailing \n characters */
  for (i=len-1; i>=0; i--)
    {
    if (retstr[i] != '\n')
      break;
    retstr[i] = '\0';
    len--;
    }

	/* Convert all \n characters into spaces */
  for (i=0; i<len; i++)
    {
    if (retstr[i] == '\n') retstr[i] = ' ';
    }

  return(retstr);
}

/* -------------------------------------------------------------*/

char *
backquote_chk(val)
char *val;
{
  int len;
  char *val2;

#ifdef DEBUG
  printf("backquote_chk: '%s'\n", val);
#endif

  if (val == NULL)
    return(NULL);

  len = strlen(val);

  if (len > 4 && val[0] == '`' && val[1] == '`' &&
	val[len-2] == '`' && val[len-1] == '`')
    {
    val[len-1] = '\0';
    STR_CPY(val2, &val[1]);
    return(val2);
    }
  else
    if (len > 2 && val[0] == '`' && val[len-1] == '`')
      {
      val[len-1] = '\0';
      val2 = backquote(&val[1]);
      return(val2);
      }
    else
      {
      STR_CPY(val2, val);
      return(val2);
      }
}

/* -------------------------------------------------------------*/

setenv_variable(var, val)
char *var;
char *val;
{
  int retval;
  char *putenv_str;

#ifdef DEBUG
  (void) printf("Setenv Variable '%s' to '%s'.\n", var, val);
#endif

  putenv_str = MALLOC_LEN(strlen(var) + strlen(val) + 2);

  STRING_COPY(putenv_str, var);
  (void) strcat(putenv_str, "=");
  (void) strcat(putenv_str, val);

  retval = putenv(putenv_str);

  if (retval != 0)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"Allocation error setting environment variable '%s' to '%s'.",
 var, val);
    process_error(0);}
}

/* -------------------------------------------------------------*/

int
setenv_command(str)
char *str;
{
  int i;
  Arg args[10];
  Position x_loc, y_loc;
  int j;
  Dimension height, width;
  int found, found2;
  int len;

  char *name;
  char *value;
  char *env_value;
  char *value2;
  int len2;

  if (setenv_cnt > NO_SETENV_CNT)
    {XBell(dpy, 0);
    (void) sprintf(error_str,"Only 1 Setenv may take place at a time.");
    process_error(0);
    return(-1);}

  setenv_cnt = 1;

  len = strlen(str);

#ifdef DEBUG
  (void) printf("Setenv String '%s' Length %d\n", str, len);
#endif

  query_location(&x_loc, &y_loc, 0);

	/* Find first non-space or non-tab character */
  found = 0;
  for (i=7; i<len; i++)
    {
    if (str[i] != ' ' && str[i] != '\t')
      {found = i;
      break;}
    }

  if (found == 0)
    {
    STR_CPY(name,"");
    STR_CPY(value,"");
    }
  else
    {
	/* Find a space or a tab character */
    found2 = 0;
    for (i=found; i<len; i++)
      {
      if (str[i] == ' ' || str[i] == '\t')
        {found2 = i;
        break;}
      }

	/* If no second field was found the value is the current
		environment variable setting. */
    if (found2 == 0)
      {
      STR_CPY(name, &str[found]);
      env_value = getenv(name);
      if (env_value == NULL)
        {
        STR_CPY(value, "");
        }
      else
        {
		/* Add backquotes to already backquoted string */
        len2 = strlen(env_value);
        if (len2 > 2 && env_value[0] == '`' && env_value[len2-1] == '`')
          {
          value = MALLOC_LEN(len2+3);
          value[0] = '`';
          value[1] = '\0';
          (void) strcat(value, env_value);
          value[len2+1] = '`';
          value[len2+2] = '\0';
          }
        else
          {
          STR_CPY(value, env_value);
          }
        }
      }
    else
      {
      name = MALLOC_LEN(found2-found+1);
      j = 0;
      for (i=found; i<found2; i++)
        {name[j] = str[i];
        j++;}
      name[j] = '\0';

	/* Find first non-space or non-tab character */
      found = 0;
      for (i=found2+1; i<len; i++)
        {
        if (str[i] != ' ' && str[i] != '\t')
          {found = i;
          break;}
        }

	/* If 3rd parameter was given set the environment variable */
      if (found == 0)
        {
        env_value = getenv(name);
        if (env_value == NULL)
          {
          STR_CPY(value,"");
          }
        else
          {
		/* Add backquotes to already backquoted string */
          len2 = strlen(env_value);
          if (len2 > 2 && env_value[0] == '`' && env_value[len2-1] == '`')
            {
            value = MALLOC_LEN(len2+3);
            value[0] = '`';
            value[1] = '\0';
            (void) strcat(value, env_value);
            value[len2+1] = '`';
            value[len2+2] = '\0';
            }
          else
            {
            STR_CPY(value, env_value);
            }
          }
        }
      else
        {
        STR_CPY(value, &str[found]);

        value2 = backquote_chk(value);

        FREE(value);

        value = value2;

        setenv_variable(name, value);

        setenv_cnt = NO_SETENV_CNT;

        FREE(name);

        FREE(value);

        return(1);
        }
      }
    }

  setenv_str1 = name;
  setenv_str2 = value;

#ifdef DEBUG
  (void) printf("Setenv Variable '%s', Value '%s'\n",
	setenv_str1, setenv_str2);
#endif

  i = 0;
  XtSetArg(args[i], XtNstring, setenv_str1); i++;
  XtSetValues(setenv_text1, args, i);

  i = 0;
  XtSetArg(args[i], XtNstring, setenv_str2); i++;
  XtSetValues(setenv_text2, args, i);

  height = (12) * switch_height + (4*DEFAULT_DISTANCE);
  width = MAX_POPUP_WIDTH;

  i = 0;
  XtSetArg(args[i], XtNheight, height); i++;
  XtSetArg(args[i], XtNwidth, width); i++;
  XtSetArg(args[i], XtNx, x_loc); i++;
  XtSetArg(args[i], XtNy, y_loc); i++;
  XtSetValues(setenv_pshell, args, i);

  XtPopup(setenv_pshell, XtGrabNone);

  FREE(name);

  FREE(value);

  return(0);
}

/* -------------------------------------------------------------*/

warp_to_location(loc)
int loc;
{
  int x, y;

  if (app_data.horizontal)
    {
    x = loc * (switch_width + (2*(DEFAULT_DISTANCE-1))) +
	(switch_width / 2) + DEFAULT_DISTANCE;

    y = (switch_height / 2) + DEFAULT_DISTANCE;
    }
  else
    {
    x = (switch_width / 2) + DEFAULT_DISTANCE;

    y = loc * (switch_height + (2*(DEFAULT_DISTANCE-1))) +
	(switch_height / 2) + DEFAULT_DISTANCE;
    }

  XWarpPointer(dpy, None, Top_Window, 0, 0, 0, 0, x, y);
}

/* -------------------------------------------------------------*/

move_pointer_up(loc)
int loc;
{
  loc--;
  if (loc < 0) loc = max_switches - 1;

  warp_to_location(loc);
}

/* -------------------------------------------------------------*/

move_pointer_down(loc)
int loc;
{
  loc++;
  if (loc >= max_switches) loc = 0;

  warp_to_location(loc);
}

/* -------------------------------------------------------------*/

	/* Add a Switch at max_switches */
add_switch()
{
  int i;
  Arg args[20];
  Dimension box_height, box_width;
  Dimension top_height, top_width;
  XSizeHints size_hints;
  char name[20];

  int add;

  add = lookup[max_switches];

#ifdef DEBUG
  (void) printf("Adding a switch at location %d\n",add);
#endif

  i=0;
  XtSetArg(args[i], XtNheight, &top_height); i++;
  XtSetArg(args[i], XtNwidth, &top_width); i++;
  XtGetValues(topLevel, args, i);

  i=0;
  XtSetArg(args[i], XtNheight, &box_height); i++;
  XtSetArg(args[i], XtNwidth, &box_width); i++;
  XtGetValues(switchbox, args, i);

  if (app_data.horizontal)
    {
    box_width += (switch_width+X_SPACE);
    top_width += (switch_width+X_SPACE);
    }
  else
    {
    box_height += (switch_height+Y_SPACE);
    top_height += (switch_height+Y_SPACE);
    }

  size_hints.min_width  = top_width;
  size_hints.min_height = top_height;
  size_hints.max_width  = top_width;
  size_hints.max_height = top_height;
  size_hints.flags = PMinSize | PMaxSize;
  XSetNormalHints(dpy, Top_Window, &size_hints);

  alive[add] = 1;

  (void) sprintf(name,"switch_%d\0",add);
  i=0;
  XtSetArg(args[i], XtNlabel, switch_lab[add]); i++;

  XtSetArg(args[i], XtNjustify, XtJustifyCenter); i++;
  XtSetArg(args[i], XtNsensitive, TRUE); i++;

  XtSetArg(args[i], XtNheight, switch_height); i++;
  XtSetArg(args[i], XtNwidth,  switch_width); i++;

  if (strcmp(switch_com[add],"!label") == 0)
    {
    XtSetArg(args[i], XtNborderColor, White); i++;
    XtSetArg(args[i], XtNhighlightThickness, 0); i++;
    XtSetArg(args[i], XtNtranslations, switch_label_translations); i++;
    label_item[add] = 1;
    }
  else
    {
    XtSetArg(args[i], XtNborderColor, Black); i++;
    XtSetArg(args[i], XtNhighlightThickness, 1); i++;
    XtSetArg(args[i], XtNtranslations, switch_command_translations); i++;
    label_item[add] = 0;
    }

  switches[add] = XtCreateManagedWidget(name, commandWidgetClass,
	switchbox, args, i);

  XtAddCallback(switches[add], XtNcallback, switch_callback, add);

  max_switches++;

  i=0;
  XtSetArg(args[i], XtNheight, box_height); i++;
  XtSetArg(args[i], XtNwidth, box_width); i++;
  XtSetValues(switchbox, args, i); 

  i=0;
  XtSetArg(args[i], XtNheight, top_height); i++;
  XtSetArg(args[i], XtNwidth, top_width); i++;
  XtSetValues(topLevel, args, i);

#ifdef DEBUG
  for (x=0; x<max_switches; x++)
    {
    (void) printf("Add lookup[%d]=%d, alive[lookup[%d]]=%d\n",
	x,lookup[x],x,alive[lookup[x]]);
    }
#endif
}

/* -------------------------------------------------------------*/
